/* $NetBSD: irix_sysent.c,v 1.60 2009/01/13 22:33:09 pooka Exp $ */

/*
 * System call switch table.
 *
 * DO NOT EDIT-- this file is automatically generated.
 * created from	NetBSD: syscalls.master,v 1.54 2009/01/13 22:27:43 pooka Exp
 */

#include <sys/cdefs.h>
__KERNEL_RCSID(0, "$NetBSD: irix_sysent.c,v 1.60 2009/01/13 22:33:09 pooka Exp $");

#if defined(_KERNEL_OPT)
#include "opt_ntp.h"
#include "opt_sysv.h"
#include "opt_compat_43.h"
#endif
#include <sys/param.h>
#include <sys/systm.h>
#include <sys/signal.h>
#include <sys/mount.h>
#include <sys/poll.h>
#include <sys/ioctl_compat.h>
#include <sys/syscallargs.h>
#include <compat/svr4/svr4_types.h>
#include <compat/svr4/svr4_signal.h>
#include <compat/svr4/svr4_ucontext.h>
#include <compat/svr4/svr4_lwp.h>
#include <compat/svr4/svr4_statvfs.h>
#include <compat/svr4/svr4_syscallargs.h>
#include <compat/irix/irix_types.h>
#include <compat/irix/irix_signal.h>
#include <compat/irix/irix_syscallargs.h>

#define	s(type)	sizeof(type)
#define	n(type)	(sizeof(type)/sizeof (register_t))
#define	ns(type)	n(type), s(type)

struct sysent irix_sysent[] = {
	{ 0, 0, 0,
	    (sy_call_t *)sys_nosys },		/* 0 = syscall */
	{ ns(struct sys_exit_args), 0,
	    (sy_call_t *)sys_exit },		/* 1 = exit */
	{ 0, 0, 0,
	    (sy_call_t *)sys_fork },		/* 2 = fork */
	{ ns(struct sys_read_args), 0,
	    (sy_call_t *)sys_read },		/* 3 = read */
	{ ns(struct sys_write_args), 0,
	    (sy_call_t *)sys_write },		/* 4 = write */
	{ ns(struct irix_sys_open_args), 0,
	    (sy_call_t *)irix_sys_open },	/* 5 = open */
	{ ns(struct sys_close_args), 0,
	    (sy_call_t *)sys_close },		/* 6 = close */
	{ 0, 0, 0,
	    sys_nosys },			/* 7 = obsolete wait */
	{ ns(struct svr4_sys_creat_args), 0,
	    (sy_call_t *)svr4_sys_creat },	/* 8 = creat */
	{ ns(struct sys_link_args), 0,
	    (sy_call_t *)sys_link },		/* 9 = link */
	{ ns(struct sys_unlink_args), 0,
	    (sy_call_t *)sys_unlink },		/* 10 = unlink */
	{ ns(struct svr4_sys_execv_args), 0,
	    (sy_call_t *)svr4_sys_execv },	/* 11 = execv */
	{ ns(struct sys_chdir_args), 0,
	    (sy_call_t *)sys_chdir },		/* 12 = chdir */
	{ ns(struct svr4_sys_time_args), 0,
	    (sy_call_t *)svr4_sys_time },	/* 13 = time */
	{ 0, 0, 0,
	    sys_nosys },			/* 14 = obsolete mknod */
	{ ns(struct sys_chmod_args), 0,
	    (sy_call_t *)sys_chmod },		/* 15 = chmod */
	{ ns(struct sys___posix_chown_args), 0,
	    (sy_call_t *)sys___posix_chown },	/* 16 = chown */
	{ ns(struct irix_sys_break_args), 0,
	    (sy_call_t *)irix_sys_break },	/* 17 = break */
	{ 0, 0, 0,
	    sys_nosys },			/* 18 = obsolete stat */
	{ ns(struct compat_43_sys_lseek_args), 0,
	    (sy_call_t *)compat_43_sys_lseek },	/* 19 = lseek */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getpid },		/* 20 = getpid */
	{ 0, 0, 0,
	    sys_nosys },			/* 21 = unimplemented old_mount */
	{ 0, 0, 0,
	    sys_nosys },			/* 22 = unimplemented System V umount */
	{ ns(struct sys_setuid_args), 0,
	    (sy_call_t *)sys_setuid },		/* 23 = setuid */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getuid_with_euid },/* 24 = getuid_with_euid */
	{ 0, 0, 0,
	    sys_nosys },			/* 25 = unimplemented stime */
	{ 0, 0, 0,
	    sys_nosys },			/* 26 = unimplemented ptrace */
	{ ns(struct svr4_sys_alarm_args), 0,
	    (sy_call_t *)svr4_sys_alarm },	/* 27 = alarm */
	{ ns(struct svr4_sys_fstat_args), 0,
	    (sy_call_t *)svr4_sys_fstat },	/* 28 = fstat */
	{ 0, 0, 0,
	    (sy_call_t *)svr4_sys_pause },	/* 29 = pause */
	{ ns(struct svr4_sys_utime_args), 0,
	    (sy_call_t *)svr4_sys_utime },	/* 30 = utime */
	{ 0, 0, 0,
	    sys_nosys },			/* 31 = unimplemented was stty */
	{ 0, 0, 0,
	    sys_nosys },			/* 32 = unimplemented was gtty */
	{ ns(struct svr4_sys_access_args), 0,
	    (sy_call_t *)svr4_sys_access },	/* 33 = access */
	{ ns(struct svr4_sys_nice_args), 0,
	    (sy_call_t *)svr4_sys_nice },	/* 34 = nice */
	{ 0, 0, 0,
	    sys_nosys },			/* 35 = unimplemented statfs */
	{ 0, 0, 0,
	    (sy_call_t *)sys_sync },		/* 36 = sync */
	{ ns(struct svr4_sys_kill_args), 0,
	    (sy_call_t *)svr4_sys_kill },	/* 37 = kill */
	{ 0, 0, 0,
	    sys_nosys },			/* 38 = unimplemented fstatfs */
	{ ns(struct svr4_sys_pgrpsys_args), 0,
	    (sy_call_t *)svr4_sys_pgrpsys },	/* 39 = pgrpsys */
	{ ns(struct irix_sys_syssgi_args), 0,
	    (sy_call_t *)irix_sys_syssgi },	/* 40 = syssgi */
	{ ns(struct sys_dup_args), 0,
	    (sy_call_t *)sys_dup },		/* 41 = dup */
	{ 0, 0, 0,
	    (sy_call_t *)sys_pipe },		/* 42 = pipe */
	{ ns(struct svr4_sys_times_args), 0,
	    (sy_call_t *)svr4_sys_times },	/* 43 = times */
	{ 0, 0, 0,
	    sys_nosys },			/* 44 = unimplemented profil */
	{ 0, 0, 0,
	    sys_nosys },			/* 45 = unimplemented plock */
	{ ns(struct sys_setgid_args), 0,
	    (sy_call_t *)sys_setgid },		/* 46 = setgid */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getgid_with_egid },/* 47 = getgid_with_egid */
	{ 0, 0, 0,
	    sys_nosys },			/* 48 = obsolete ssig */
#ifdef SYSVMSG
	{ ns(struct svr4_sys_msgsys_args), 0,
	    (sy_call_t *)svr4_sys_msgsys },	/* 49 = msgsys */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 49 = unimplemented msgsys */
#endif
	{ 0, 0, 0,
	    sys_nosys },			/* 50 = unimplemented sysmips */
	{ 0, 0, 0,
	    sys_nosys },			/* 51 = unimplemented acct */
#ifdef SYSVSHM
	{ ns(struct irix_sys_shmsys_args), 0,
	    (sy_call_t *)irix_sys_shmsys },	/* 52 = shmsys */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 52 = unimplemented shmsys */
#endif
#ifdef SYSVSEM
	{ ns(struct svr4_sys_semsys_args), 0,
	    (sy_call_t *)svr4_sys_semsys },	/* 53 = semsys */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 53 = unimplemented semsys */
#endif
	{ ns(struct irix_sys_ioctl_args), 0,
	    (sy_call_t *)irix_sys_ioctl },	/* 54 = ioctl */
	{ 0, 0, 0,
	    sys_nosys },			/* 55 = unimplemented uadmin */
	{ ns(struct irix_sys_sysmp_args), 0,
	    (sy_call_t *)irix_sys_sysmp },	/* 56 = sysmp */
	{ ns(struct irix_sys_utssys_args), 0,
	    (sy_call_t *)irix_sys_utssys },	/* 57 = utssys */
	{ 0, 0, 0,
	    sys_nosys },			/* 58 = unimplemented */
	{ ns(struct svr4_sys_execve_args), 0,
	    (sy_call_t *)svr4_sys_execve },	/* 59 = execve */
	{ ns(struct sys_umask_args), 0,
	    (sy_call_t *)sys_umask },		/* 60 = umask */
	{ ns(struct sys_chroot_args), 0,
	    (sy_call_t *)sys_chroot },		/* 61 = chroot */
	{ ns(struct irix_sys_fcntl_args), 0,
	    (sy_call_t *)irix_sys_fcntl },	/* 62 = fcntl */
	{ ns(struct svr4_sys_ulimit_args), 0,
	    (sy_call_t *)svr4_sys_ulimit },	/* 63 = ulimit */
	{ 0, 0, 0,
	    sys_nosys },			/* 64 = unimplemented reserved for unix/pc */
	{ 0, 0, 0,
	    sys_nosys },			/* 65 = unimplemented reserved for unix/pc */
	{ 0, 0, 0,
	    sys_nosys },			/* 66 = unimplemented reserved for unix/pc */
	{ 0, 0, 0,
	    sys_nosys },			/* 67 = unimplemented reserved for unix/pc */
	{ 0, 0, 0,
	    sys_nosys },			/* 68 = unimplemented reserved for unix/pc */
	{ 0, 0, 0,
	    sys_nosys },			/* 69 = unimplemented reserved for unix/pc */
	{ 0, 0, 0,
	    sys_nosys },			/* 70 = obsolete advfs */
	{ 0, 0, 0,
	    sys_nosys },			/* 71 = obsolete unadvfs */
	{ 0, 0, 0,
	    sys_nosys },			/* 72 = obsolete rmount */
	{ 0, 0, 0,
	    sys_nosys },			/* 73 = obsolete rumount */
	{ 0, 0, 0,
	    sys_nosys },			/* 74 = obsolete rfstart */
	{ ns(struct irix_sys_getrlimit64_args), 0,
	    (sy_call_t *)irix_sys_getrlimit64 },/* 75 = getrlimit64 */
	{ ns(struct irix_sys_setrlimit64_args), 0,
	    (sy_call_t *)irix_sys_setrlimit64 },/* 76 = setrlimit64 */
	{ ns(struct compat_50_sys_nanosleep_args), 0,
	    (sy_call_t *)compat_50_sys_nanosleep },/* 77 = nanosleep */
	{ ns(struct irix_sys_lseek64_args), 0,
	    (sy_call_t *)irix_sys_lseek64 },	/* 78 = lseek64 */
	{ ns(struct sys_rmdir_args), 0,
	    (sy_call_t *)sys_rmdir },		/* 79 = rmdir */
	{ ns(struct sys_mkdir_args), 0,
	    (sy_call_t *)sys_mkdir },		/* 80 = mkdir */
	{ ns(struct irix_sys_getdents_args), 0,
	    (sy_call_t *)irix_sys_getdents },	/* 81 = getdents */
	{ ns(struct irix_sys_sginap_args), 0,
	    (sy_call_t *)irix_sys_sginap },	/* 82 = sginap */
	{ 0, 0, 0,
	    sys_nosys },			/* 83 = unimplemented sgikopt */
	{ 0, 0, 0,
	    sys_nosys },			/* 84 = unimplemented sysfs */
	{ ns(struct svr4_sys_getmsg_args), 0,
	    (sy_call_t *)svr4_sys_getmsg },	/* 85 = getmsg */
	{ ns(struct svr4_sys_putmsg_args), 0,
	    (sy_call_t *)svr4_sys_putmsg },	/* 86 = putmsg */
	{ ns(struct sys_poll_args), 0,
	    (sy_call_t *)sys_poll },		/* 87 = poll */
	{ ns(struct irix_sys_sigreturn_args), 0,
	    (sy_call_t *)irix_sys_sigreturn },	/* 88 = sigreturn */
	{ ns(struct compat_43_sys_accept_args), 0,
	    (sy_call_t *)compat_43_sys_accept },/* 89 = accept */
	{ ns(struct sys_bind_args), 0,
	    (sy_call_t *)sys_bind },		/* 90 = bind */
	{ ns(struct sys_connect_args), 0,
	    (sy_call_t *)sys_connect },		/* 91 = connect */
	{ 0, 0, 0,
	    (sy_call_t *)compat_43_sys_gethostid },/* 92 = gethostid */
	{ ns(struct compat_43_sys_getpeername_args), 0,
	    (sy_call_t *)compat_43_sys_getpeername },/* 93 = getpeername */
	{ ns(struct compat_43_sys_getsockname_args), 0,
	    (sy_call_t *)compat_43_sys_getsockname },/* 94 = getsockname */
	{ ns(struct sys_getsockopt_args), 0,
	    (sy_call_t *)sys_getsockopt },	/* 95 = getsockopt */
	{ ns(struct sys_listen_args), 0,
	    (sy_call_t *)sys_listen },		/* 96 = listen */
	{ ns(struct compat_43_sys_recv_args), 0,
	    (sy_call_t *)compat_43_sys_recv },	/* 97 = recv */
	{ ns(struct compat_43_sys_recvfrom_args), 0,
	    (sy_call_t *)compat_43_sys_recvfrom },/* 98 = recvfrom */
	{ ns(struct compat_43_sys_recvmsg_args), 0,
	    (sy_call_t *)compat_43_sys_recvmsg },/* 99 = recvmsg */
	{ ns(struct compat_50_sys_select_args), 0,
	    (sy_call_t *)compat_50_sys_select },/* 100 = select */
	{ ns(struct compat_43_sys_send_args), 0,
	    (sy_call_t *)compat_43_sys_send },	/* 101 = send */
	{ ns(struct compat_43_sys_sendmsg_args), 0,
	    (sy_call_t *)compat_43_sys_sendmsg },/* 102 = sendmsg */
	{ ns(struct sys_sendto_args), 0,
	    (sy_call_t *)sys_sendto },		/* 103 = sendto */
	{ ns(struct compat_43_sys_sethostid_args), 0,
	    (sy_call_t *)compat_43_sys_sethostid },/* 104 = sethostid */
	{ ns(struct sys_setsockopt_args), 0,
	    (sy_call_t *)sys_setsockopt },	/* 105 = setsockopt */
	{ ns(struct sys_shutdown_args), 0,
	    (sy_call_t *)sys_shutdown },	/* 106 = shutdown */
	{ ns(struct svr4_sys_socket_args), 0,
	    (sy_call_t *)svr4_sys_socket },	/* 107 = socket */
	{ ns(struct compat_43_sys_gethostname_args), 0,
	    (sy_call_t *)compat_43_sys_gethostname },/* 108 = gethostname */
	{ ns(struct compat_43_sys_sethostname_args), 0,
	    (sy_call_t *)compat_43_sys_sethostname },/* 109 = sethostname */
	{ ns(struct compat_09_sys_getdomainname_args), 0,
	    (sy_call_t *)compat_09_sys_getdomainname },/* 110 = getdomainname */
	{ ns(struct compat_09_sys_setdomainname_args), 0,
	    (sy_call_t *)compat_09_sys_setdomainname },/* 111 = setdomainname */
	{ ns(struct sys_truncate_args), 0,
	    (sy_call_t *)sys_truncate },	/* 112 = truncate */
	{ ns(struct sys_ftruncate_args), 0,
	    (sy_call_t *)sys_ftruncate },	/* 113 = ftruncate */
	{ ns(struct sys_rename_args), 0,
	    (sy_call_t *)sys_rename },		/* 114 = rename */
	{ ns(struct sys_symlink_args), 0,
	    (sy_call_t *)sys_symlink },		/* 115 = symlink */
	{ ns(struct sys_readlink_args), 0,
	    (sy_call_t *)sys_readlink },	/* 116 = readlink */
	{ 0, 0, 0,
	    sys_nosys },			/* 117 = unimplemented lstat */
	{ 0, 0, 0,
	    sys_nosys },			/* 118 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 119 = unimplemented nfs_svc */
	{ 0, 0, 0,
	    sys_nosys },			/* 120 = unimplemented nfs_getfh */
	{ 0, 0, 0,
	    sys_nosys },			/* 121 = unimplemented async_daemon */
	{ 0, 0, 0,
	    sys_nosys },			/* 122 = unimplemented exportfs */
	{ ns(struct sys_setregid_args), 0,
	    (sy_call_t *)sys_setregid },	/* 123 = setregid */
	{ ns(struct sys_setreuid_args), 0,
	    (sy_call_t *)sys_setreuid },	/* 124 = setreuid */
	{ ns(struct compat_50_sys_getitimer_args), 0,
	    (sy_call_t *)compat_50_sys_getitimer },/* 125 = getitimer */
	{ ns(struct compat_50_sys_setitimer_args), 0,
	    (sy_call_t *)compat_50_sys_setitimer },/* 126 = setitimer */
	{ ns(struct compat_50_sys_adjtime_args), 0,
	    (sy_call_t *)compat_50_sys_adjtime },/* 127 = adjtime */
	{ ns(struct svr4_sys_gettimeofday_args), 0,
	    (sy_call_t *)svr4_sys_gettimeofday },/* 128 = gettimeofday */
	{ ns(struct irix_sys_sproc_args), 0,
	    (sy_call_t *)irix_sys_sproc },	/* 129 = sproc */
	{ ns(struct irix_sys_prctl_args), 0,
	    (sy_call_t *)irix_sys_prctl },	/* 130 = prctl */
	{ ns(struct irix_sys_procblk_args), 0,
	    (sy_call_t *)irix_sys_procblk },	/* 131 = procblk */
	{ ns(struct irix_sys_sprocsp_args), 0,
	    (sy_call_t *)irix_sys_sprocsp },	/* 132 = sprocsp */
	{ 0, 0, 0,
	    sys_nosys },			/* 133 = unimplemented sgigsc */
	{ ns(struct irix_sys_mmap_args), 0,
	    (sy_call_t *)irix_sys_mmap },	/* 134 = mmap */
	{ ns(struct irix_sys_munmap_args), 0,
	    (sy_call_t *)irix_sys_munmap },	/* 135 = munmap */
	{ ns(struct irix_sys_mprotect_args), 0,
	    (sy_call_t *)irix_sys_mprotect },	/* 136 = mprotect */
	{ ns(struct sys___msync13_args), 0,
	    (sy_call_t *)sys___msync13 },	/* 137 = __msync13 */
	{ 0, 0, 0,
	    sys_nosys },			/* 138 = unimplemented madvise */
	{ 0, 0, 0,
	    sys_nosys },			/* 139 = unimplemented pagelock */
	{ 0, 0, 0,
	    sys_nosys },			/* 140 = unimplemented getpagesize */
	{ 0, 0, 0,
	    sys_nosys },			/* 141 = unimplemented quotactl */
	{ 0, 0, 0,
	    sys_nosys },			/* 142 = unimplemented */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getpgrp },		/* 143 = getpgrp */
	{ ns(struct irix_sys_setpgrp_args), 0,
	    (sy_call_t *)irix_sys_setpgrp },	/* 144 = setpgrp */
	{ 0, 0, 0,
	    sys_nosys },			/* 145 = unimplemented vhangup */
	{ ns(struct sys_fsync_args), 0,
	    (sy_call_t *)sys_fsync },		/* 146 = fsync */
	{ ns(struct sys_fchdir_args), 0,
	    (sy_call_t *)sys_fchdir },		/* 147 = fchdir */
	{ ns(struct irix_sys_getrlimit_args), 0,
	    (sy_call_t *)irix_sys_getrlimit },	/* 148 = getrlimit */
	{ ns(struct irix_sys_setrlimit_args), 0,
	    (sy_call_t *)irix_sys_setrlimit },	/* 149 = setrlimit */
	{ 0, 0, 0,
	    sys_nosys },			/* 150 = unimplemented cacheflush */
	{ 0, 0, 0,
	    sys_nosys },			/* 151 = unimplemented cachectl */
	{ ns(struct sys___posix_fchown_args), 0,
	    (sy_call_t *)sys___posix_fchown },	/* 152 = fchown */
	{ ns(struct sys_fchmod_args), 0,
	    (sy_call_t *)sys_fchmod },		/* 153 = fchmod */
	{ 0, 0, 0,
	    sys_nosys },			/* 154 = unimplemented wait3 */
	{ 0, 0, 0,
	    sys_nosys },			/* 155 = unimplemented socketpair */
	{ ns(struct irix_sys_systeminfo_args), 0,
	    (sy_call_t *)irix_sys_systeminfo },	/* 156 = systeminfo */
	{ ns(struct irix_sys_uname_args), 0,
	    (sy_call_t *)irix_sys_uname },	/* 157 = uname */
	{ ns(struct irix_sys_xstat_args), 0,
	    (sy_call_t *)irix_sys_xstat },	/* 158 = xstat */
	{ ns(struct irix_sys_lxstat_args), 0,
	    (sy_call_t *)irix_sys_lxstat },	/* 159 = lxstat */
	{ ns(struct irix_sys_fxstat_args), 0,
	    (sy_call_t *)irix_sys_fxstat },	/* 160 = fxstat */
	{ 0, 0, 0,
	    sys_nosys },			/* 161 = unimplemented xmknod */
	{ ns(struct irix_sys_sigaction_args), 0,
	    (sy_call_t *)irix_sys_sigaction },	/* 162 = sigaction */
	{ ns(struct svr4_sys_sigpending_args), 0,
	    (sy_call_t *)svr4_sys_sigpending },	/* 163 = sigpending */
	{ ns(struct irix_sys_sigprocmask_args), 0,
	    (sy_call_t *)irix_sys_sigprocmask },/* 164 = sigprocmask */
	{ ns(struct svr4_sys_sigsuspend_args), 0,
	    (sy_call_t *)svr4_sys_sigsuspend },	/* 165 = sigsuspend */
	{ 0, 0, 0,
	    sys_nosys },			/* 166 = unimplemented sigpoll_sys */
	{ ns(struct irix_sys_swapctl_args), 0,
	    (sy_call_t *)irix_sys_swapctl },	/* 167 = swapctl */
	{ ns(struct irix_sys_getcontext_args), 0,
	    (sy_call_t *)irix_sys_getcontext },	/* 168 = getcontext */
	{ ns(struct irix_sys_setcontext_args), 0,
	    (sy_call_t *)irix_sys_setcontext },	/* 169 = setcontext */
	{ ns(struct irix_sys_waitsys_args), 0,
	    (sy_call_t *)irix_sys_waitsys },	/* 170 = waitsys */
	{ 0, 0, 0,
	    sys_nosys },			/* 171 = unimplemented sigstack */
	{ 0, 0, 0,
	    sys_nosys },			/* 172 = unimplemented sigaltstack */
	{ 0, 0, 0,
	    sys_nosys },			/* 173 = unimplemented sigsendset */
	{ ns(struct svr4_sys_statvfs_args), 0,
	    (sy_call_t *)svr4_sys_statvfs },	/* 174 = statvfs */
	{ ns(struct svr4_sys_fstatvfs_args), 0,
	    (sy_call_t *)svr4_sys_fstatvfs },	/* 175 = fstatvfs */
	{ 0, 0, 0,
	    sys_nosys },			/* 176 = unimplemented getpmsg */
	{ 0, 0, 0,
	    sys_nosys },			/* 177 = unimplemented putpmsg */
	{ 0, 0, 0,
	    sys_nosys },			/* 178 = unimplemented lchown */
	{ 0, 0, 0,
	    sys_nosys },			/* 179 = unimplemented priocntl */
	{ 0, 0, 0,
	    sys_nosys },			/* 180 = unimplemented sigqueue */
	{ ns(struct sys_readv_args), 0,
	    (sy_call_t *)sys_readv },		/* 181 = readv */
	{ ns(struct sys_writev_args), 0,
	    (sy_call_t *)sys_writev },		/* 182 = writev */
	{ ns(struct sys_truncate_args), 0,
	    (sy_call_t *)sys_truncate },	/* 183 = truncate64 */
	{ ns(struct sys_ftruncate_args), 0,
	    (sy_call_t *)sys_ftruncate },	/* 184 = ftruncate64 */
	{ ns(struct irix_sys_mmap64_args), 0,
	    (sy_call_t *)irix_sys_mmap64 },	/* 185 = mmap64 */
	{ 0, 0, 0,
	    sys_nosys },			/* 186 = unimplemented dmi */
	{ ns(struct svr4_sys_pread_args), 0,
	    (sy_call_t *)svr4_sys_pread },	/* 187 = pread */
	{ ns(struct svr4_sys_pwrite_args), 0,
	    (sy_call_t *)svr4_sys_pwrite },	/* 188 = pwrite */
	{ 0, 0, 0,
	    sys_nosys },			/* 189 = unimplemented fdatasync */
	{ 0, 0, 0,
	    sys_nosys },			/* 190 = unimplemented sgifastpath */
	{ 0, 0, 0,
	    sys_nosys },			/* 191 = unimplemented attr_get */
	{ 0, 0, 0,
	    sys_nosys },			/* 192 = unimplemented attr_getf */
	{ 0, 0, 0,
	    sys_nosys },			/* 193 = unimplemented attr_set */
	{ 0, 0, 0,
	    sys_nosys },			/* 194 = unimplemented attr_setf */
	{ 0, 0, 0,
	    sys_nosys },			/* 195 = unimplemented attr_remove */
	{ 0, 0, 0,
	    sys_nosys },			/* 196 = unimplemented attr_removef */
	{ 0, 0, 0,
	    sys_nosys },			/* 197 = unimplemented attr_list */
	{ 0, 0, 0,
	    sys_nosys },			/* 198 = unimplemented attr_listf */
	{ 0, 0, 0,
	    sys_nosys },			/* 199 = unimplemented attr_multi */
	{ 0, 0, 0,
	    sys_nosys },			/* 200 = unimplemented attr_multif */
	{ 0, 0, 0,
	    sys_nosys },			/* 201 = unimplemented statvfs64 */
	{ 0, 0, 0,
	    sys_nosys },			/* 202 = unimplemented fstatvfs64 */
	{ ns(struct irix_sys_getmountid_args), 0,
	    (sy_call_t *)irix_sys_getmountid },	/* 203 = getmountid */
	{ 0, 0, 0,
	    sys_nosys },			/* 204 = unimplemented nsproc */
	{ ns(struct irix_sys_getdents64_args), 0,
	    (sy_call_t *)irix_sys_getdents64 },	/* 205 = getdents64 */
	{ 0, 0, 0,
	    sys_nosys },			/* 206 = unimplemented afs_syscall */
	{ ns(struct irix_sys_ngetdents_args), 0,
	    (sy_call_t *)irix_sys_ngetdents },	/* 207 = ngetdents */
	{ ns(struct irix_sys_ngetdents64_args), 0,
	    (sy_call_t *)irix_sys_ngetdents64 },/* 208 = ngetdents64 */
	{ 0, 0, 0,
	    sys_nosys },			/* 209 = unimplemented sgi_sesmgr */
	{ ns(struct irix_sys_pidsprocsp_args), 0,
	    (sy_call_t *)irix_sys_pidsprocsp },	/* 210 = pidsprocsp */
	{ 0, 0, 0,
	    sys_nosys },			/* 211 = unimplemented rexec */
	{ 0, 0, 0,
	    sys_nosys },			/* 212 = unimplemented timer_create */
	{ 0, 0, 0,
	    sys_nosys },			/* 213 = unimplemented timer_delete */
	{ 0, 0, 0,
	    sys_nosys },			/* 214 = unimplemented timer_settime */
	{ 0, 0, 0,
	    sys_nosys },			/* 215 = unimplemented timer_gettime */
	{ 0, 0, 0,
	    sys_nosys },			/* 216 = unimplemented timer_setoverrun */
	{ 0, 0, 0,
	    sys_nosys },			/* 217 = unimplemented sched_rr_get_interval */
	{ 0, 0, 0,
	    sys_nosys },			/* 218 = unimplemented sched_yield */
	{ 0, 0, 0,
	    sys_nosys },			/* 219 = unimplemented sched_getscheduler */
	{ 0, 0, 0,
	    sys_nosys },			/* 220 = unimplemented sched_setscheduler */
	{ 0, 0, 0,
	    sys_nosys },			/* 221 = unimplemented sched_getparam */
	{ 0, 0, 0,
	    sys_nosys },			/* 222 = unimplemented sched_setparam */
	{ ns(struct irix_sys_usync_cntl_args), 0,
	    (sy_call_t *)irix_sys_usync_cntl },	/* 223 = usync_cntl */
	{ 0, 0, 0,
	    sys_nosys },			/* 224 = unimplemented psema_cntl */
	{ 0, 0, 0,
	    sys_nosys },			/* 225 = unimplemented restartreturn */
	{ 0, 0, 0,
	    sys_nosys },			/* 226 = unimplemented sysget */
	{ 0, 0, 0,
	    sys_nosys },			/* 227 = unimplemented xpg4_recvmsg */
	{ 0, 0, 0,
	    sys_nosys },			/* 228 = unimplemented umfscall */
	{ 0, 0, 0,
	    sys_nosys },			/* 229 = unimplemented nsproctid */
	{ 0, 0, 0,
	    sys_nosys },			/* 230 = unimplemented rexec_complete */
	{ 0, 0, 0,
	    sys_nosys },			/* 231 = unimplemented xpg4_sigaltstack */
	{ 0, 0, 0,
	    sys_nosys },			/* 232 = unimplemented xpg4_sigaltstack */
	{ 0, 0, 0,
	    sys_nosys },			/* 233 = unimplemented xpg4_setregid */
	{ 0, 0, 0,
	    sys_nosys },			/* 234 = unimplemented linkfollow */
	{ 0, 0, 0,
	    sys_nosys },			/* 235 = unimplemented utimets */
	{ 0, 0, 0,
	    sys_nosys },			/* 236 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 237 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 238 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 239 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 240 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 241 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 242 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 243 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 244 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 245 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 246 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 247 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 248 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 249 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 250 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 251 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 252 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 253 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 254 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 255 = filler */
};

