/* $NetBSD: linux_sysent.c,v 1.75 2009/06/17 14:20:08 njoly Exp $ */

/*
 * System call switch table.
 *
 * DO NOT EDIT-- this file is automatically generated.
 * created from	NetBSD: syscalls.master,v 1.70 2009/06/17 14:18:51 njoly Exp
 */

#include <sys/cdefs.h>
__KERNEL_RCSID(0, "$NetBSD: linux_sysent.c,v 1.75 2009/06/17 14:20:08 njoly Exp $");

#if defined(_KERNEL_OPT)
#include "opt_sysv.h"
#endif
#include <sys/param.h>
#include <sys/poll.h>
#include <sys/systm.h>
#include <sys/signal.h>
#include <sys/mount.h>
#include <sys/syscallargs.h>
#include <compat/linux/common/linux_types.h>
#include <compat/linux/common/linux_signal.h>
#include <compat/linux/common/linux_siginfo.h>
#include <compat/linux/common/linux_ipc.h>
#include <compat/linux/common/linux_msg.h>
#include <compat/linux/common/linux_sem.h>
#include <compat/linux/common/linux_shm.h>
#include <compat/linux/common/linux_mmap.h>
#include <compat/linux/linux_syscallargs.h>

#define	s(type)	sizeof(type)
#define	n(type)	(sizeof(type)/sizeof (register_t))
#define	ns(type)	n(type), s(type)

struct sysent linux_sysent[] = {
	{ 0, 0, 0,
	    (sy_call_t *)linux_sys_nosys },	/* 0 = syscall */
	{ ns(struct sys_exit_args), 0,
	    (sy_call_t *)sys_exit },		/* 1 = exit */
	{ 0, 0, 0,
	    (sy_call_t *)sys_fork },		/* 2 = fork */
	{ ns(struct sys_read_args), 0,
	    (sy_call_t *)sys_read },		/* 3 = read */
	{ ns(struct sys_write_args), 0,
	    (sy_call_t *)sys_write },		/* 4 = write */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 5 = unimplemented */
	{ ns(struct sys_close_args), 0,
	    (sy_call_t *)sys_close },		/* 6 = close */
	{ ns(struct osf1_sys_wait4_args), 0,
	    (sy_call_t *)osf1_sys_wait4 },	/* 7 = wait4 */
	{ ns(struct linux_sys_creat_args), 0,
	    (sy_call_t *)linux_sys_creat },	/* 8 = creat */
	{ ns(struct sys_link_args), 0,
	    (sy_call_t *)sys_link },		/* 9 = link */
	{ ns(struct linux_sys_unlink_args), 0,
	    (sy_call_t *)linux_sys_unlink },	/* 10 = unlink */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 11 = unimplemented */
	{ ns(struct sys_chdir_args), 0,
	    (sy_call_t *)sys_chdir },		/* 12 = chdir */
	{ ns(struct sys_fchdir_args), 0,
	    (sy_call_t *)sys_fchdir },		/* 13 = fchdir */
	{ ns(struct linux_sys_mknod_args), 0,
	    (sy_call_t *)linux_sys_mknod },	/* 14 = mknod */
	{ ns(struct sys_chmod_args), 0,
	    (sy_call_t *)sys_chmod },		/* 15 = chmod */
	{ ns(struct sys___posix_chown_args), 0,
	    (sy_call_t *)sys___posix_chown },	/* 16 = __posix_chown */
	{ ns(struct linux_sys_brk_args), 0,
	    (sy_call_t *)linux_sys_brk },	/* 17 = brk */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 18 = unimplemented */
	{ ns(struct compat_43_sys_lseek_args), 0,
	    (sy_call_t *)compat_43_sys_lseek },	/* 19 = lseek */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getpid_with_ppid },/* 20 = getpid_with_ppid */
	{ ns(struct osf1_sys_mount_args), 0,
	    (sy_call_t *)osf1_sys_mount },	/* 21 = mount */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 22 = unimplemented umount */
	{ ns(struct sys_setuid_args), 0,
	    (sy_call_t *)sys_setuid },		/* 23 = setuid */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getuid_with_euid },/* 24 = getuid_with_euid */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 25 = unimplemented */
	{ ns(struct linux_sys_ptrace_args), 0,
	    (sy_call_t *)linux_sys_ptrace },	/* 26 = ptrace */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 27 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 28 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 29 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 30 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 31 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 32 = unimplemented */
	{ ns(struct sys_access_args), 0,
	    (sy_call_t *)sys_access },		/* 33 = access */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 34 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 35 = unimplemented */
	{ 0, 0, 0,
	    (sy_call_t *)sys_sync },		/* 36 = sync */
	{ ns(struct linux_sys_kill_args), 0,
	    (sy_call_t *)linux_sys_kill },	/* 37 = kill */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 38 = unimplemented */
	{ ns(struct sys_setpgid_args), 0,
	    (sy_call_t *)sys_setpgid },		/* 39 = setpgid */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 40 = unimplemented */
	{ ns(struct sys_dup_args), 0,
	    (sy_call_t *)sys_dup },		/* 41 = dup */
	{ 0, 0, 0,
	    (sy_call_t *)linux_sys_pipe },	/* 42 = pipe */
	{ ns(struct osf1_sys_set_program_attributes_args), 0,
	    (sy_call_t *)osf1_sys_set_program_attributes },/* 43 = set_program_attributes */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 44 = unimplemented */
	{ ns(struct linux_sys_open_args), 0,
	    (sy_call_t *)linux_sys_open },	/* 45 = open */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 46 = unimplemented */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getgid_with_egid },/* 47 = getgid_with_egid */
	{ ns(struct compat_13_sys_sigprocmask_args), 0,
	    (sy_call_t *)compat_13_sys_sigprocmask },/* 48 = sigprocmask */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 49 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 50 = unimplemented */
	{ ns(struct sys_acct_args), 0,
	    (sy_call_t *)sys_acct },		/* 51 = acct */
	{ ns(struct linux_sys_sigpending_args), 0,
	    (sy_call_t *)linux_sys_sigpending },/* 52 = sigpending */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 53 = unimplemented */
	{ ns(struct linux_sys_ioctl_args), 0,
	    (sy_call_t *)linux_sys_ioctl },	/* 54 = ioctl */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 55 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 56 = unimplemented */
	{ ns(struct sys_symlink_args), 0,
	    (sy_call_t *)sys_symlink },		/* 57 = symlink */
	{ ns(struct sys_readlink_args), 0,
	    (sy_call_t *)sys_readlink },	/* 58 = readlink */
	{ ns(struct sys_execve_args), 0,
	    (sy_call_t *)sys_execve },		/* 59 = execve */
	{ ns(struct sys_umask_args), 0,
	    (sy_call_t *)sys_umask },		/* 60 = umask */
	{ ns(struct sys_chroot_args), 0,
	    (sy_call_t *)sys_chroot },		/* 61 = chroot */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 62 = unimplemented */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getpgrp },		/* 63 = getpgrp */
	{ 0, 0, 0,
	    (sy_call_t *)compat_43_sys_getpagesize },/* 64 = getpagesize */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 65 = unimplemented */
	{ 0, 0, 0,
	    (sy_call_t *)sys___vfork14 },	/* 66 = __vfork14 */
	{ ns(struct linux_sys_stat_args), 0,
	    (sy_call_t *)linux_sys_stat },	/* 67 = stat */
	{ ns(struct linux_sys_lstat_args), 0,
	    (sy_call_t *)linux_sys_lstat },	/* 68 = lstat */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 69 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 70 = unimplemented */
	{ ns(struct linux_sys_mmap_args), 0,
	    (sy_call_t *)linux_sys_mmap },	/* 71 = mmap */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 72 = unimplemented */
	{ ns(struct sys_munmap_args), 0,
	    (sy_call_t *)sys_munmap },		/* 73 = munmap */
	{ ns(struct linux_sys_mprotect_args), 0,
	    (sy_call_t *)linux_sys_mprotect },	/* 74 = mprotect */
	{ ns(struct sys_madvise_args), 0,
	    (sy_call_t *)sys_madvise },		/* 75 = madvise */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 76 = unimplemented vhangup */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 77 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 78 = unimplemented */
	{ ns(struct sys_getgroups_args), 0,
	    (sy_call_t *)sys_getgroups },	/* 79 = getgroups */
	{ ns(struct sys_setgroups_args), 0,
	    (sy_call_t *)sys_setgroups },	/* 80 = setgroups */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 81 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 82 = unimplemented setpgrp */
	{ ns(struct osf1_sys_setitimer_args), 0,
	    (sy_call_t *)osf1_sys_setitimer },	/* 83 = setitimer */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 84 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 85 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 86 = unimplemented osf1_sys_getitimer */
	{ ns(struct compat_43_sys_gethostname_args), 0,
	    (sy_call_t *)compat_43_sys_gethostname },/* 87 = gethostname */
	{ ns(struct compat_43_sys_sethostname_args), 0,
	    (sy_call_t *)compat_43_sys_sethostname },/* 88 = sethostname */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 89 = unimplemented getdtablesize */
	{ ns(struct sys_dup2_args), 0,
	    (sy_call_t *)sys_dup2 },		/* 90 = dup2 */
	{ ns(struct linux_sys_fstat_args), 0,
	    (sy_call_t *)linux_sys_fstat },	/* 91 = fstat */
	{ ns(struct linux_sys_fcntl_args), 0,
	    (sy_call_t *)linux_sys_fcntl },	/* 92 = fcntl */
	{ ns(struct osf1_sys_select_args), 0,
	    (sy_call_t *)osf1_sys_select },	/* 93 = select */
	{ ns(struct sys_poll_args), 0,
	    (sy_call_t *)sys_poll },		/* 94 = poll */
	{ ns(struct sys_fsync_args), 0,
	    (sy_call_t *)sys_fsync },		/* 95 = fsync */
	{ ns(struct sys_setpriority_args), 0,
	    (sy_call_t *)sys_setpriority },	/* 96 = setpriority */
	{ ns(struct linux_sys_socket_args), 0,
	    (sy_call_t *)linux_sys_socket },	/* 97 = socket */
	{ ns(struct linux_sys_connect_args), 0,
	    (sy_call_t *)linux_sys_connect },	/* 98 = connect */
	{ ns(struct linux_sys_accept_args), 0,
	    (sy_call_t *)linux_sys_accept },	/* 99 = accept */
	{ ns(struct linux_sys_getpriority_args), 0,
	    (sy_call_t *)linux_sys_getpriority },/* 100 = getpriority */
	{ ns(struct linux_sys_send_args), 0,
	    (sy_call_t *)linux_sys_send },	/* 101 = send */
	{ ns(struct linux_sys_recv_args), 0,
	    (sy_call_t *)linux_sys_recv },	/* 102 = recv */
	{ ns(struct linux_sys_sigreturn_args), 0,
	    (sy_call_t *)linux_sys_sigreturn },	/* 103 = sigreturn */
	{ ns(struct linux_sys_bind_args), 0,
	    (sy_call_t *)linux_sys_bind },	/* 104 = bind */
	{ ns(struct linux_sys_setsockopt_args), 0,
	    (sy_call_t *)linux_sys_setsockopt },/* 105 = setsockopt */
	{ ns(struct sys_listen_args), 0,
	    (sy_call_t *)sys_listen },		/* 106 = listen */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 107 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 108 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 109 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 110 = unimplemented */
	{ ns(struct linux_sys_sigsuspend_args), 0,
	    (sy_call_t *)linux_sys_sigsuspend },/* 111 = sigsuspend */
	{ ns(struct compat_43_sys_sigstack_args), 0,
	    (sy_call_t *)compat_43_sys_sigstack },/* 112 = sigstack */
	{ ns(struct linux_sys_recvmsg_args), 0,
	    (sy_call_t *)linux_sys_recvmsg },	/* 113 = recvmsg */
	{ ns(struct linux_sys_sendmsg_args), 0,
	    (sy_call_t *)linux_sys_sendmsg },	/* 114 = sendmsg */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 115 = unimplemented */
	{ ns(struct osf1_sys_gettimeofday_args), 0,
	    (sy_call_t *)osf1_sys_gettimeofday },/* 116 = gettimeofday */
	{ ns(struct osf1_sys_getrusage_args), 0,
	    (sy_call_t *)osf1_sys_getrusage },	/* 117 = getrusage */
	{ ns(struct linux_sys_getsockopt_args), 0,
	    (sy_call_t *)linux_sys_getsockopt },/* 118 = getsockopt */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 119 = unimplemented */
	{ ns(struct sys_readv_args), 0,
	    (sy_call_t *)sys_readv },		/* 120 = readv */
	{ ns(struct sys_writev_args), 0,
	    (sy_call_t *)sys_writev },		/* 121 = writev */
	{ ns(struct osf1_sys_settimeofday_args), 0,
	    (sy_call_t *)osf1_sys_settimeofday },/* 122 = settimeofday */
	{ ns(struct sys___posix_fchown_args), 0,
	    (sy_call_t *)sys___posix_fchown },	/* 123 = __posix_fchown */
	{ ns(struct sys_fchmod_args), 0,
	    (sy_call_t *)sys_fchmod },		/* 124 = fchmod */
	{ ns(struct linux_sys_recvfrom_args), 0,
	    (sy_call_t *)linux_sys_recvfrom },	/* 125 = recvfrom */
	{ ns(struct sys_setreuid_args), 0,
	    (sy_call_t *)sys_setreuid },	/* 126 = setreuid */
	{ ns(struct sys_setregid_args), 0,
	    (sy_call_t *)sys_setregid },	/* 127 = setregid */
	{ ns(struct sys___posix_rename_args), 0,
	    (sy_call_t *)sys___posix_rename },	/* 128 = __posix_rename */
	{ ns(struct compat_43_sys_truncate_args), 0,
	    (sy_call_t *)compat_43_sys_truncate },/* 129 = truncate */
	{ ns(struct compat_43_sys_ftruncate_args), 0,
	    (sy_call_t *)compat_43_sys_ftruncate },/* 130 = ftruncate */
	{ ns(struct sys_flock_args), 0,
	    (sy_call_t *)sys_flock },		/* 131 = flock */
	{ ns(struct sys_setgid_args), 0,
	    (sy_call_t *)sys_setgid },		/* 132 = setgid */
	{ ns(struct linux_sys_sendto_args), 0,
	    (sy_call_t *)linux_sys_sendto },	/* 133 = sendto */
	{ ns(struct sys_shutdown_args), 0,
	    (sy_call_t *)sys_shutdown },	/* 134 = shutdown */
	{ ns(struct linux_sys_socketpair_args), 0,
	    (sy_call_t *)linux_sys_socketpair },/* 135 = socketpair */
	{ ns(struct sys_mkdir_args), 0,
	    (sy_call_t *)sys_mkdir },		/* 136 = mkdir */
	{ ns(struct sys_rmdir_args), 0,
	    (sy_call_t *)sys_rmdir },		/* 137 = rmdir */
	{ ns(struct osf1_sys_utimes_args), 0,
	    (sy_call_t *)osf1_sys_utimes },	/* 138 = utimes */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 139 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 140 = unimplemented */
	{ ns(struct linux_sys_getpeername_args), 0,
	    (sy_call_t *)linux_sys_getpeername },/* 141 = getpeername */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 142 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 143 = unimplemented */
	{ ns(struct linux_sys_getrlimit_args), 0,
	    (sy_call_t *)linux_sys_getrlimit },	/* 144 = getrlimit */
	{ ns(struct linux_sys_setrlimit_args), 0,
	    (sy_call_t *)linux_sys_setrlimit },	/* 145 = setrlimit */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 146 = unimplemented */
	{ 0, 0, 0,
	    (sy_call_t *)sys_setsid },		/* 147 = setsid */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 148 = unimplemented quotactl */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 149 = unimplemented */
	{ ns(struct linux_sys_getsockname_args), 0,
	    (sy_call_t *)linux_sys_getsockname },/* 150 = getsockname */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 151 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 152 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 153 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 154 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 155 = unimplemented */
	{ ns(struct linux_sys_sigaction_args), 0,
	    (sy_call_t *)linux_sys_sigaction },	/* 156 = sigaction */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 157 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 158 = unimplemented */
	{ ns(struct compat_43_sys_getdirentries_args), 0,
	    (sy_call_t *)compat_43_sys_getdirentries },/* 159 = getdirentries */
	{ ns(struct osf1_sys_statfs_args), 0,
	    (sy_call_t *)osf1_sys_statfs },	/* 160 = statfs */
	{ ns(struct osf1_sys_fstatfs_args), 0,
	    (sy_call_t *)osf1_sys_fstatfs },	/* 161 = fstatfs */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 162 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 163 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 164 = unimplemented */
	{ ns(struct compat_09_sys_getdomainname_args), 0,
	    (sy_call_t *)compat_09_sys_getdomainname },/* 165 = getdomainname */
	{ ns(struct linux_sys_setdomainname_args), 0,
	    (sy_call_t *)linux_sys_setdomainname },/* 166 = setdomainname */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 167 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 168 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 169 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 170 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 171 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 172 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 173 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 174 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 175 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 176 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 177 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 178 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 179 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 180 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 181 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 182 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 183 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 184 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 185 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 186 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 187 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 188 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 189 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 190 = unimplemented */
	{ ns(struct linux_sys_ugetrlimit_args), 0,
	    (sy_call_t *)linux_sys_ugetrlimit },/* 191 = ugetrlimit */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 192 = unimplemented mmap2 */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 193 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 194 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 195 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 196 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 197 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 198 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 199 = unimplemented osf1_sys_swapon */
#ifdef SYSVMSG
	{ ns(struct linux_sys_msgctl_args), 0,
	    (sy_call_t *)linux_sys_msgctl },	/* 200 = msgctl */
	{ ns(struct sys_msgget_args), 0,
	    (sy_call_t *)sys_msgget },		/* 201 = msgget */
	{ ns(struct sys_msgrcv_args), 0,
	    (sy_call_t *)sys_msgrcv },		/* 202 = msgrcv */
	{ ns(struct sys_msgsnd_args), 0,
	    (sy_call_t *)sys_msgsnd },		/* 203 = msgsnd */
#else
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 200 = unimplemented msgctl */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 201 = unimplemented msgget */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 202 = unimplemented msgrcv */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 203 = unimplemented msgsnd */
#endif
#ifdef SYSVSEM
	{ ns(struct linux_sys_semctl_args), 0,
	    (sy_call_t *)linux_sys_semctl },	/* 204 = semctl */
	{ ns(struct sys_semget_args), 0,
	    (sy_call_t *)sys_semget },		/* 205 = semget */
	{ ns(struct sys_semop_args), 0,
	    (sy_call_t *)sys_semop },		/* 206 = semop */
#else
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 204 = unimplemented semctl */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 205 = unimplemented semget */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 206 = unimplemented semop */
#endif
	{ ns(struct linux_sys_olduname_args), 0,
	    (sy_call_t *)linux_sys_olduname },	/* 207 = olduname */
	{ ns(struct sys___posix_lchown_args), 0,
	    (sy_call_t *)sys___posix_lchown },	/* 208 = __posix_lchown */
#ifdef SYSVSHM
	{ ns(struct linux_sys_shmat_args), 0,
	    (sy_call_t *)linux_sys_shmat },	/* 209 = shmat */
	{ ns(struct linux_sys_shmctl_args), 0,
	    (sy_call_t *)linux_sys_shmctl },	/* 210 = shmctl */
	{ ns(struct sys_shmdt_args), 0,
	    (sy_call_t *)sys_shmdt },		/* 211 = shmdt */
	{ ns(struct linux_sys_shmget_args), 0,
	    (sy_call_t *)linux_sys_shmget },	/* 212 = shmget */
#else
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 209 = unimplemented shmat */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 210 = unimplemented shmctl */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 211 = unimplemented shmdt */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 212 = unimplemented shmget */
#endif
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 213 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 214 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 215 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 216 = unimplemented */
	{ ns(struct sys___msync13_args), 0,
	    (sy_call_t *)sys___msync13 },	/* 217 = __msync13 */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 218 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 219 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 220 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 221 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 222 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 223 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 224 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 225 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 226 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 227 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 228 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 229 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 230 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 231 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 232 = unimplemented */
	{ ns(struct sys_getpgid_args), 0,
	    (sy_call_t *)sys_getpgid },		/* 233 = getpgid */
	{ ns(struct sys_getsid_args), 0,
	    (sy_call_t *)sys_getsid },		/* 234 = getsid */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 235 = unimplemented sigaltstack */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 236 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 237 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 238 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 239 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 240 = unimplemented */
	{ ns(struct osf1_sys_sysinfo_args), 0,
	    (sy_call_t *)osf1_sys_sysinfo },	/* 241 = sysinfo */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 242 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 243 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 244 = unimplemented osf1_sys_proplist_syscall */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 245 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 246 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 247 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 248 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 249 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 250 = unimplemented */
	{ ns(struct osf1_sys_usleep_thread_args), 0,
	    (sy_call_t *)osf1_sys_usleep_thread },/* 251 = usleep_thread */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 252 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 253 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 254 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 255 = unimplemented sysfs */
	{ ns(struct osf1_sys_getsysinfo_args), 0,
	    (sy_call_t *)osf1_sys_getsysinfo },	/* 256 = getsysinfo */
	{ ns(struct osf1_sys_setsysinfo_args), 0,
	    (sy_call_t *)osf1_sys_setsysinfo },	/* 257 = setsysinfo */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 258 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 259 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 260 = unimplemented */
	{ ns(struct linux_sys_fdatasync_args), 0,
	    (sy_call_t *)linux_sys_fdatasync },	/* 261 = fdatasync */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 262 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 263 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 264 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 265 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 266 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 267 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 268 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 269 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 270 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 271 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 272 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 273 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 274 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 275 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 276 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 277 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 278 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 279 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 280 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 281 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 282 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 283 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 284 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 285 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 286 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 287 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 288 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 289 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 290 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 291 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 292 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 293 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 294 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 295 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 296 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 297 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 298 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 299 = unimplemented */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 300 = unimplemented bdflush */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 301 = unimplemented sethae */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 302 = unimplemented mount */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 303 = unimplemented old_adjtimex */
	{ ns(struct linux_sys_swapoff_args), 0,
	    (sy_call_t *)linux_sys_swapoff },	/* 304 = swapoff */
	{ ns(struct linux_sys_getdents_args), 0,
	    (sy_call_t *)linux_sys_getdents },	/* 305 = getdents */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 306 = unimplemented alpha_create_module */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 307 = unimplemented init_module */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 308 = unimplemented delete_module */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 309 = unimplemented get_kernel_syms */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 310 = unimplemented syslog */
	{ ns(struct linux_sys_reboot_args), 0,
	    (sy_call_t *)linux_sys_reboot },	/* 311 = reboot */
	{ ns(struct linux_sys_clone_args), 0,
	    (sy_call_t *)linux_sys_clone },	/* 312 = clone */
#ifdef EXEC_AOUT
	{ ns(struct linux_sys_uselib_args), 0,
	    (sy_call_t *)linux_sys_uselib },	/* 313 = uselib */
#else
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 313 = unimplemented sys_uselib */
#endif
	{ ns(struct sys_mlock_args), 0,
	    (sy_call_t *)sys_mlock },		/* 314 = mlock */
	{ ns(struct sys_munlock_args), 0,
	    (sy_call_t *)sys_munlock },		/* 315 = munlock */
	{ ns(struct sys_mlockall_args), 0,
	    (sy_call_t *)sys_mlockall },	/* 316 = mlockall */
	{ 0, 0, 0,
	    (sy_call_t *)sys_munlockall },	/* 317 = munlockall */
	{ ns(struct linux_sys_sysinfo_args), 0,
	    (sy_call_t *)linux_sys_sysinfo },	/* 318 = sysinfo */
	{ ns(struct linux_sys___sysctl_args), 0,
	    (sy_call_t *)linux_sys___sysctl },	/* 319 = __sysctl */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 320 = unimplemented idle */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 321 = unimplemented oldumount */
	{ ns(struct linux_sys_swapon_args), 0,
	    (sy_call_t *)linux_sys_swapon },	/* 322 = swapon */
	{ ns(struct linux_sys_times_args), 0,
	    (sy_call_t *)linux_sys_times },	/* 323 = times */
	{ ns(struct linux_sys_personality_args), 0,
	    (sy_call_t *)linux_sys_personality },/* 324 = personality */
	{ ns(struct linux_sys_setfsuid_args), 0,
	    (sy_call_t *)linux_sys_setfsuid },	/* 325 = setfsuid */
	{ ns(struct linux_sys_setfsgid_args), 0,
	    (sy_call_t *)linux_sys_setfsgid },	/* 326 = setfsgid */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 327 = unimplemented ustat */
	{ ns(struct linux_sys_statfs_args), 0,
	    (sy_call_t *)linux_sys_statfs },	/* 328 = statfs */
	{ ns(struct linux_sys_fstatfs_args), 0,
	    (sy_call_t *)linux_sys_fstatfs },	/* 329 = fstatfs */
	{ ns(struct linux_sys_sched_setparam_args), 0,
	    (sy_call_t *)linux_sys_sched_setparam },/* 330 = sched_setparam */
	{ ns(struct linux_sys_sched_getparam_args), 0,
	    (sy_call_t *)linux_sys_sched_getparam },/* 331 = sched_getparam */
	{ ns(struct linux_sys_sched_setscheduler_args), 0,
	    (sy_call_t *)linux_sys_sched_setscheduler },/* 332 = sched_setscheduler */
	{ ns(struct linux_sys_sched_getscheduler_args), 0,
	    (sy_call_t *)linux_sys_sched_getscheduler },/* 333 = sched_getscheduler */
	{ 0, 0, 0,
	    (sy_call_t *)linux_sys_sched_yield },/* 334 = sched_yield */
	{ ns(struct linux_sys_sched_get_priority_max_args), 0,
	    (sy_call_t *)linux_sys_sched_get_priority_max },/* 335 = sched_get_priority_max */
	{ ns(struct linux_sys_sched_get_priority_min_args), 0,
	    (sy_call_t *)linux_sys_sched_get_priority_min },/* 336 = sched_get_priority_min */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 337 = unimplemented sched_rr_get_interval */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 338 = unimplemented afs_syscall */
	{ ns(struct linux_sys_uname_args), 0,
	    (sy_call_t *)linux_sys_uname },	/* 339 = uname */
	{ ns(struct linux_sys_nanosleep_args), 0,
	    (sy_call_t *)linux_sys_nanosleep },	/* 340 = nanosleep */
	{ ns(struct linux_sys_mremap_args), 0,
	    (sy_call_t *)linux_sys_mremap },	/* 341 = mremap */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 342 = unimplemented nfsservctl */
	{ ns(struct linux_sys_setresuid_args), 0,
	    (sy_call_t *)linux_sys_setresuid },	/* 343 = setresuid */
	{ ns(struct linux_sys_getresuid_args), 0,
	    (sy_call_t *)linux_sys_getresuid },	/* 344 = getresuid */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 345 = unimplemented pciconfig_read */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 346 = unimplemented pciconfig_write */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 347 = unimplemented query_module */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 348 = unimplemented prctl */
	{ ns(struct linux_sys_pread_args), 0,
	    (sy_call_t *)linux_sys_pread },	/* 349 = pread */
	{ ns(struct linux_sys_pwrite_args), 0,
	    (sy_call_t *)linux_sys_pwrite },	/* 350 = pwrite */
	{ ns(struct linux_sys_rt_sigreturn_args), 0,
	    (sy_call_t *)linux_sys_rt_sigreturn },/* 351 = rt_sigreturn */
	{ ns(struct linux_sys_rt_sigaction_args), 0,
	    (sy_call_t *)linux_sys_rt_sigaction },/* 352 = rt_sigaction */
	{ ns(struct linux_sys_rt_sigprocmask_args), 0,
	    (sy_call_t *)linux_sys_rt_sigprocmask },/* 353 = rt_sigprocmask */
	{ ns(struct linux_sys_rt_sigpending_args), 0,
	    (sy_call_t *)linux_sys_rt_sigpending },/* 354 = rt_sigpending */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 355 = unimplemented rt_sigtimedwait */
	{ ns(struct linux_sys_rt_queueinfo_args), 0,
	    (sy_call_t *)linux_sys_rt_queueinfo },/* 356 = rt_queueinfo */
	{ ns(struct linux_sys_rt_sigsuspend_args), 0,
	    (sy_call_t *)linux_sys_rt_sigsuspend },/* 357 = rt_sigsuspend */
	{ ns(struct linux_sys_select_args), 0,
	    (sy_call_t *)linux_sys_select },	/* 358 = select */
	{ ns(struct compat_50_sys_gettimeofday_args), 0,
	    (sy_call_t *)compat_50_sys_gettimeofday },/* 359 = gettimeofday */
	{ ns(struct compat_50_sys_settimeofday_args), 0,
	    (sy_call_t *)compat_50_sys_settimeofday },/* 360 = settimeofday */
	{ ns(struct compat_50_sys_getitimer_args), 0,
	    (sy_call_t *)compat_50_sys_getitimer },/* 361 = getitimer */
	{ ns(struct compat_50_sys_setitimer_args), 0,
	    (sy_call_t *)compat_50_sys_setitimer },/* 362 = setitimer */
	{ ns(struct compat_50_sys_utimes_args), 0,
	    (sy_call_t *)compat_50_sys_utimes },/* 363 = utimes */
	{ ns(struct compat_50_sys_getrusage_args), 0,
	    (sy_call_t *)compat_50_sys_getrusage },/* 364 = getrusage */
	{ ns(struct linux_sys_wait4_args), 0,
	    (sy_call_t *)linux_sys_wait4 },	/* 365 = wait4 */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 366 = unimplemented adjtimex */
	{ ns(struct sys___getcwd_args), 0,
	    (sy_call_t *)sys___getcwd },	/* 367 = __getcwd */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 368 = unimplemented capget */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 369 = unimplemented capset */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 370 = unimplemented sendfile */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 371 = unimplemented setresgid */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 372 = unimplemented getresgid */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 373 = unimplemented sys_dipc */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 374 = unimplemented pivot_root */
	{ ns(struct sys_mincore_args), 0,
	    (sy_call_t *)sys_mincore },		/* 375 = mincore */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 376 = unimplemented pciconfig_iobase */
	{ ns(struct linux_sys_getdents64_args), 0,
	    (sy_call_t *)linux_sys_getdents64 },/* 377 = getdents64 */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 378 = unimplemented gettid */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 379 = unimplemented readahead */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 380 = unimplemented / * unused * / */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 381 = unimplemented tkill */
	{ ns(struct linux_sys_setxattr_args), 0,
	    (sy_call_t *)linux_sys_setxattr },	/* 382 = setxattr */
	{ ns(struct linux_sys_lsetxattr_args), 0,
	    (sy_call_t *)linux_sys_lsetxattr },	/* 383 = lsetxattr */
	{ ns(struct linux_sys_fsetxattr_args), 0,
	    (sy_call_t *)linux_sys_fsetxattr },	/* 384 = fsetxattr */
	{ ns(struct linux_sys_getxattr_args), 0,
	    (sy_call_t *)linux_sys_getxattr },	/* 385 = getxattr */
	{ ns(struct linux_sys_lgetxattr_args), 0,
	    (sy_call_t *)linux_sys_lgetxattr },	/* 386 = lgetxattr */
	{ ns(struct linux_sys_fgetxattr_args), 0,
	    (sy_call_t *)linux_sys_fgetxattr },	/* 387 = fgetxattr */
	{ ns(struct linux_sys_listxattr_args), 0,
	    (sy_call_t *)linux_sys_listxattr },	/* 388 = listxattr */
	{ ns(struct linux_sys_llistxattr_args), 0,
	    (sy_call_t *)linux_sys_llistxattr },/* 389 = llistxattr */
	{ ns(struct linux_sys_flistxattr_args), 0,
	    (sy_call_t *)linux_sys_flistxattr },/* 390 = flistxattr */
	{ ns(struct linux_sys_removexattr_args), 0,
	    (sy_call_t *)linux_sys_removexattr },/* 391 = removexattr */
	{ ns(struct linux_sys_lremovexattr_args), 0,
	    (sy_call_t *)linux_sys_lremovexattr },/* 392 = lremovexattr */
	{ ns(struct linux_sys_fremovexattr_args), 0,
	    (sy_call_t *)linux_sys_fremovexattr },/* 393 = fremovexattr */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 394 = unimplemented futex */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 395 = unimplemented sched_setaffinity */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 396 = unimplemented sched_getaffinity */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 397 = unimplemented tuxcall */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 398 = unimplemented io_setup */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 399 = unimplemented io_destroy */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 400 = unimplemented io_getevents */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 401 = unimplemented io_submit */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 402 = unimplemented io_cancel */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 403 = unimplemented / * unused * / */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 404 = unimplemented / * unused * / */
	{ ns(struct linux_sys_exit_group_args), 0,
	    (sy_call_t *)linux_sys_exit_group },/* 405 = exit_group */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 406 = unimplemented lookup_dcookie */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 407 = unimplemented sys_epoll_create */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 408 = unimplemented sys_epoll_ctl */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 409 = unimplemented sys_epoll_wait */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 410 = unimplemented remap_file_pages */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 411 = unimplemented set_tid_address */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 412 = unimplemented restart_syscall */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 413 = unimplemented fadvise64 */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 414 = unimplemented timer_create */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 415 = unimplemented timer_settime */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 416 = unimplemented timer_gettime */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 417 = unimplemented timer_getoverrun */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 418 = unimplemented timer_delete */
	{ ns(struct linux_sys_clock_settime_args), 0,
	    (sy_call_t *)linux_sys_clock_settime },/* 419 = clock_settime */
	{ ns(struct linux_sys_clock_gettime_args), 0,
	    (sy_call_t *)linux_sys_clock_gettime },/* 420 = clock_gettime */
	{ ns(struct linux_sys_clock_getres_args), 0,
	    (sy_call_t *)linux_sys_clock_getres },/* 421 = clock_getres */
	{ ns(struct linux_sys_clock_nanosleep_args), 0,
	    (sy_call_t *)linux_sys_clock_nanosleep },/* 422 = clock_nanosleep */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 423 = unimplemented semtimedop */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 424 = unimplemented tgkill */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 425 = unimplemented stat64 */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 426 = unimplemented lstat64 */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 427 = unimplemented fstat64 */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 428 = unimplemented vserver */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 429 = unimplemented mbind */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 430 = unimplemented get_mempolicy */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 431 = unimplemented set_mempolicy */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 432 = unimplemented mq_open */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 433 = unimplemented mq_unlink */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 434 = unimplemented mq_timedsend */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 435 = unimplemented mq_timedreceive */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 436 = unimplemented mq_notify */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 437 = unimplemented mq_getsetattr */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 438 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 439 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 440 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 441 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 442 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 443 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 444 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 445 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 446 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 447 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 448 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 449 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 450 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 451 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 452 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 453 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 454 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 455 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 456 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 457 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 458 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 459 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 460 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 461 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 462 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 463 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 464 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 465 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 466 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 467 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 468 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 469 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 470 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 471 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 472 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 473 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 474 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 475 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 476 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 477 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 478 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 479 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 480 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 481 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 482 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 483 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 484 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 485 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 486 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 487 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 488 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 489 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 490 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 491 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 492 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 493 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 494 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 495 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 496 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 497 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 498 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 499 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 500 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 501 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 502 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 503 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 504 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 505 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 506 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 507 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 508 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 509 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 510 = filler */
	{ 0, 0, 0,
	    linux_sys_nosys },			/* 511 = filler */
};
