/* $NetBSD: netbsd32_sysent.c,v 1.87 2009/05/17 05:55:42 pooka Exp $ */

/*
 * System call switch table.
 *
 * DO NOT EDIT-- this file is automatically generated.
 * created from	NetBSD: syscalls.master,v 1.80 2009/05/17 05:54:22 pooka Exp
 */

#include <sys/cdefs.h>
__KERNEL_RCSID(0, "$NetBSD: netbsd32_sysent.c,v 1.87 2009/05/17 05:55:42 pooka Exp $");

#if defined(_KERNEL_OPT)
#include "opt_compat_netbsd.h"
#include "opt_ntp.h"
#include "opt_sysv.h"
#include "opt_compat_43.h"
#include "opt_posix.h"
#include "fs_lfs.h"
#include "fs_nfs.h"
#endif
#include <sys/param.h>
#include <sys/systm.h>
#include <sys/signal.h>
#include <sys/mount.h>
#include <sys/syscallargs.h>
#include <compat/netbsd32/netbsd32.h>
#include <compat/netbsd32/netbsd32_syscallargs.h>

#ifdef COMPAT_43
#define	compat_43(func) __CONCAT(compat_43_,func)
#else
#define	compat_43(func) sys_nosys
#endif

#ifdef COMPAT_09
#define	compat_09(func) __CONCAT(compat_09_,func)
#else
#define	compat_09(func) sys_nosys
#endif

#ifdef COMPAT_10
#define	compat_10(func) __CONCAT(compat_10_,func)
#else
#define	compat_10(func) sys_nosys
#endif

#ifdef COMPAT_11
#define	compat_11(func) __CONCAT(compat_11_,func)
#else
#define	compat_11(func) sys_nosys
#endif

#ifdef COMPAT_12
#define	compat_12(func) __CONCAT(compat_12_,func)
#else
#define	compat_12(func) sys_nosys
#endif

#ifdef COMPAT_13
#define	compat_13(func) __CONCAT(compat_13_,func)
#else
#define	compat_13(func) sys_nosys
#endif

#ifdef COMPAT_14
#define	compat_14(func) __CONCAT(compat_14_,func)
#else
#define	compat_14(func) sys_nosys
#endif

#ifdef COMPAT_15
#define	compat_15(func) __CONCAT(compat_15_,func)
#else
#define	compat_15(func) sys_nosys
#endif

#ifdef COMPAT_16
#define	compat_16(func) __CONCAT(compat_16_,func)
#else
#define	compat_16(func) sys_nosys
#endif

#ifdef COMPAT_20
#define	compat_20(func) __CONCAT(compat_20_,func)
#else
#define	compat_20(func) sys_nosys
#endif

#ifdef COMPAT_30
#define	compat_30(func) __CONCAT(compat_30_,func)
#else
#define	compat_30(func) sys_nosys
#endif

#ifdef COMPAT_40
#define	compat_40(func) __CONCAT(compat_40_,func)
#else
#define	compat_40(func) sys_nosys
#endif

#ifdef COMPAT_50
#define	compat_50(func) __CONCAT(compat_50_,func)
#else
#define	compat_50(func) sys_nosys
#endif

#define	s(type)	sizeof(type)
#define	n(type)	(sizeof(type)/sizeof (register32_t))
#define	ns(type)	n(type), s(type)

struct sysent netbsd32_sysent[] = {
	{ ns(struct netbsd32_syscall_args), SYCALL_INDIRECT,
	    (sy_call_t *)netbsd32_syscall },	/* 0 = netbsd32_syscall */
	{ ns(struct netbsd32_exit_args), 0,
	    (sy_call_t *)netbsd32_exit },	/* 1 = netbsd32_exit */
	{ 0, 0, 0,
	    (sy_call_t *)sys_fork },		/* 2 = fork */
	{ ns(struct netbsd32_read_args), 0,
	    (sy_call_t *)netbsd32_read },	/* 3 = netbsd32_read */
	{ ns(struct netbsd32_write_args), 0,
	    (sy_call_t *)netbsd32_write },	/* 4 = netbsd32_write */
	{ ns(struct netbsd32_open_args), 0,
	    (sy_call_t *)netbsd32_open },	/* 5 = netbsd32_open */
	{ ns(struct netbsd32_close_args), 0,
	    (sy_call_t *)netbsd32_close },	/* 6 = netbsd32_close */
	{ ns(struct compat_50_netbsd32_wait4_args), 0,
	    (sy_call_t *)compat_50(netbsd32_wait4) },/* 7 = compat_50_netbsd32_wait4 */
	{ ns(struct compat_43_netbsd32_ocreat_args), 0,
	    (sy_call_t *)compat_43(netbsd32_ocreat) },/* 8 = compat_43_netbsd32_ocreat */
	{ ns(struct netbsd32_link_args), 0,
	    (sy_call_t *)netbsd32_link },	/* 9 = netbsd32_link */
	{ ns(struct netbsd32_unlink_args), 0,
	    (sy_call_t *)netbsd32_unlink },	/* 10 = netbsd32_unlink */
	{ 0, 0, 0,
	    sys_nosys },			/* 11 = obsolete execv */
	{ ns(struct netbsd32_chdir_args), 0,
	    (sy_call_t *)netbsd32_chdir },	/* 12 = netbsd32_chdir */
	{ ns(struct netbsd32_fchdir_args), 0,
	    (sy_call_t *)netbsd32_fchdir },	/* 13 = netbsd32_fchdir */
	{ ns(struct compat_50_netbsd32_mknod_args), 0,
	    (sy_call_t *)compat_50(netbsd32_mknod) },/* 14 = compat_50_netbsd32_mknod */
	{ ns(struct netbsd32_chmod_args), 0,
	    (sy_call_t *)netbsd32_chmod },	/* 15 = netbsd32_chmod */
	{ ns(struct netbsd32_chown_args), 0,
	    (sy_call_t *)netbsd32_chown },	/* 16 = netbsd32_chown */
	{ ns(struct netbsd32_break_args), 0,
	    (sy_call_t *)netbsd32_break },	/* 17 = netbsd32_break */
	{ ns(struct compat_20_netbsd32_getfsstat_args), 0,
	    (sy_call_t *)compat_20(netbsd32_getfsstat) },/* 18 = compat_20_netbsd32_getfsstat */
	{ ns(struct compat_43_netbsd32_olseek_args), 0,
	    (sy_call_t *)compat_43(netbsd32_olseek) },/* 19 = compat_43_netbsd32_olseek */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getpid },		/* 20 = getpid */
	{ ns(struct netbsd32_mount_args), 0,
	    (sy_call_t *)netbsd32_mount },	/* 21 = netbsd32_mount */
	{ ns(struct netbsd32_unmount_args), 0,
	    (sy_call_t *)netbsd32_unmount },	/* 22 = netbsd32_unmount */
	{ ns(struct netbsd32_setuid_args), 0,
	    (sy_call_t *)netbsd32_setuid },	/* 23 = netbsd32_setuid */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getuid },		/* 24 = getuid */
	{ 0, 0, 0,
	    (sy_call_t *)sys_geteuid },		/* 25 = geteuid */
	{ ns(struct netbsd32_ptrace_args), 0,
	    (sy_call_t *)netbsd32_ptrace },	/* 26 = netbsd32_ptrace */
	{ ns(struct netbsd32_recvmsg_args), 0,
	    (sy_call_t *)netbsd32_recvmsg },	/* 27 = netbsd32_recvmsg */
	{ ns(struct netbsd32_sendmsg_args), 0,
	    (sy_call_t *)netbsd32_sendmsg },	/* 28 = netbsd32_sendmsg */
	{ ns(struct netbsd32_recvfrom_args), 0,
	    (sy_call_t *)netbsd32_recvfrom },	/* 29 = netbsd32_recvfrom */
	{ ns(struct netbsd32_accept_args), 0,
	    (sy_call_t *)netbsd32_accept },	/* 30 = netbsd32_accept */
	{ ns(struct netbsd32_getpeername_args), 0,
	    (sy_call_t *)netbsd32_getpeername },/* 31 = netbsd32_getpeername */
	{ ns(struct netbsd32_getsockname_args), 0,
	    (sy_call_t *)netbsd32_getsockname },/* 32 = netbsd32_getsockname */
	{ ns(struct netbsd32_access_args), 0,
	    (sy_call_t *)netbsd32_access },	/* 33 = netbsd32_access */
	{ ns(struct netbsd32_chflags_args), 0,
	    (sy_call_t *)netbsd32_chflags },	/* 34 = netbsd32_chflags */
	{ ns(struct netbsd32_fchflags_args), 0,
	    (sy_call_t *)netbsd32_fchflags },	/* 35 = netbsd32_fchflags */
	{ 0, 0, 0,
	    (sy_call_t *)sys_sync },		/* 36 = sync */
	{ ns(struct netbsd32_kill_args), 0,
	    (sy_call_t *)netbsd32_kill },	/* 37 = netbsd32_kill */
	{ ns(struct compat_43_netbsd32_stat43_args), 0,
	    (sy_call_t *)compat_43(netbsd32_stat43) },/* 38 = compat_43_netbsd32_stat43 */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getppid },		/* 39 = getppid */
	{ ns(struct compat_43_netbsd32_lstat43_args), 0,
	    (sy_call_t *)compat_43(netbsd32_lstat43) },/* 40 = compat_43_netbsd32_lstat43 */
	{ ns(struct netbsd32_dup_args), 0,
	    (sy_call_t *)netbsd32_dup },	/* 41 = netbsd32_dup */
	{ 0, 0, 0,
	    (sy_call_t *)sys_pipe },		/* 42 = pipe */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getegid },		/* 43 = getegid */
	{ ns(struct netbsd32_profil_args), 0,
	    (sy_call_t *)netbsd32_profil },	/* 44 = netbsd32_profil */
	{ ns(struct netbsd32_ktrace_args), 0,
	    (sy_call_t *)netbsd32_ktrace },	/* 45 = netbsd32_ktrace */
	{ ns(struct netbsd32_sigaction_args), 0,
	    (sy_call_t *)netbsd32_sigaction },	/* 46 = netbsd32_sigaction */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getgid },		/* 47 = getgid */
	{ ns(struct compat_13_netbsd32_sigprocmask_args), 0,
	    (sy_call_t *)compat_13(netbsd32_sigprocmask) },/* 48 = compat_13_sigprocmask13 */
	{ ns(struct netbsd32___getlogin_args), 0,
	    (sy_call_t *)netbsd32___getlogin },	/* 49 = netbsd32___getlogin */
	{ ns(struct netbsd32_setlogin_args), 0,
	    (sy_call_t *)netbsd32_setlogin },	/* 50 = netbsd32_setlogin */
	{ ns(struct netbsd32_acct_args), 0,
	    (sy_call_t *)netbsd32_acct },	/* 51 = netbsd32_acct */
	{ 0, 0, 0,
	    (sy_call_t *)compat_13(sys_sigpending) },/* 52 = compat_13_sigpending13 */
	{ ns(struct compat_13_netbsd32_sigaltstack13_args), 0,
	    (sy_call_t *)compat_13(netbsd32_sigaltstack13) },/* 53 = compat_13_netbsd32_sigaltstack13 */
	{ ns(struct netbsd32_ioctl_args), 0,
	    (sy_call_t *)netbsd32_ioctl },	/* 54 = netbsd32_ioctl */
	{ ns(struct compat_12_netbsd32_reboot_args), 0,
	    (sy_call_t *)compat_12(netbsd32_reboot) },/* 55 = compat_12_netbsd32_reboot */
	{ ns(struct netbsd32_revoke_args), 0,
	    (sy_call_t *)netbsd32_revoke },	/* 56 = netbsd32_revoke */
	{ ns(struct netbsd32_symlink_args), 0,
	    (sy_call_t *)netbsd32_symlink },	/* 57 = netbsd32_symlink */
	{ ns(struct netbsd32_readlink_args), 0,
	    (sy_call_t *)netbsd32_readlink },	/* 58 = netbsd32_readlink */
	{ ns(struct netbsd32_execve_args), 0,
	    (sy_call_t *)netbsd32_execve },	/* 59 = netbsd32_execve */
	{ ns(struct netbsd32_umask_args), 0,
	    (sy_call_t *)netbsd32_umask },	/* 60 = netbsd32_umask */
	{ ns(struct netbsd32_chroot_args), 0,
	    (sy_call_t *)netbsd32_chroot },	/* 61 = netbsd32_chroot */
	{ ns(struct compat_43_netbsd32_fstat43_args), 0,
	    (sy_call_t *)compat_43(netbsd32_fstat43) },/* 62 = compat_43_netbsd32_fstat43 */
	{ ns(struct compat_43_netbsd32_ogetkerninfo_args), 0,
	    (sy_call_t *)compat_43(netbsd32_ogetkerninfo) },/* 63 = compat_43_netbsd32_ogetkerninfo */
	{ 0, 0, 0,
	    (sy_call_t *)compat_43(sys_getpagesize) },/* 64 = compat_43_ogetpagesize */
	{ ns(struct compat_12_netbsd32_msync_args), 0,
	    (sy_call_t *)compat_12(netbsd32_msync) },/* 65 = compat_12_netbsd32_msync */
	{ 0, 0, 0,
	    (sy_call_t *)sys_vfork },		/* 66 = vfork */
	{ 0, 0, 0,
	    sys_nosys },			/* 67 = obsolete vread */
	{ 0, 0, 0,
	    sys_nosys },			/* 68 = obsolete vwrite */
	{ ns(struct netbsd32_sbrk_args), 0,
	    (sy_call_t *)netbsd32_sbrk },	/* 69 = netbsd32_sbrk */
	{ ns(struct netbsd32_sstk_args), 0,
	    (sy_call_t *)netbsd32_sstk },	/* 70 = netbsd32_sstk */
	{ ns(struct compat_43_netbsd32_ommap_args), 0,
	    (sy_call_t *)compat_43(netbsd32_ommap) },/* 71 = compat_43_netbsd32_ommap */
	{ ns(struct netbsd32_ovadvise_args), 0,
	    (sy_call_t *)netbsd32_ovadvise },	/* 72 = vadvise */
	{ ns(struct netbsd32_munmap_args), 0,
	    (sy_call_t *)netbsd32_munmap },	/* 73 = netbsd32_munmap */
	{ ns(struct netbsd32_mprotect_args), 0,
	    (sy_call_t *)netbsd32_mprotect },	/* 74 = netbsd32_mprotect */
	{ ns(struct netbsd32_madvise_args), 0,
	    (sy_call_t *)netbsd32_madvise },	/* 75 = netbsd32_madvise */
	{ 0, 0, 0,
	    sys_nosys },			/* 76 = obsolete vhangup */
	{ 0, 0, 0,
	    sys_nosys },			/* 77 = obsolete vlimit */
	{ ns(struct netbsd32_mincore_args), 0,
	    (sy_call_t *)netbsd32_mincore },	/* 78 = netbsd32_mincore */
	{ ns(struct netbsd32_getgroups_args), 0,
	    (sy_call_t *)netbsd32_getgroups },	/* 79 = netbsd32_getgroups */
	{ ns(struct netbsd32_setgroups_args), 0,
	    (sy_call_t *)netbsd32_setgroups },	/* 80 = netbsd32_setgroups */
	{ 0, 0, 0,
	    (sy_call_t *)sys_getpgrp },		/* 81 = getpgrp */
	{ ns(struct netbsd32_setpgid_args), 0,
	    (sy_call_t *)netbsd32_setpgid },	/* 82 = netbsd32_setpgid */
	{ ns(struct compat_50_netbsd32_setitimer_args), 0,
	    (sy_call_t *)compat_50(netbsd32_setitimer) },/* 83 = compat_50_netbsd32_setitimer */
	{ 0, 0, 0,
	    (sy_call_t *)compat_43(sys_wait) },	/* 84 = compat_43_owait */
	{ ns(struct compat_12_netbsd32_oswapon_args), 0,
	    (sy_call_t *)compat_12(netbsd32_oswapon) },/* 85 = compat_12_netbsd32_oswapon */
	{ ns(struct compat_50_netbsd32_getitimer_args), 0,
	    (sy_call_t *)compat_50(netbsd32_getitimer) },/* 86 = compat_50_netbsd32_getitimer */
	{ ns(struct compat_43_netbsd32_ogethostname_args), 0,
	    (sy_call_t *)compat_43(netbsd32_ogethostname) },/* 87 = compat_43_netbsd32_ogethostname */
	{ ns(struct compat_43_netbsd32_osethostname_args), 0,
	    (sy_call_t *)compat_43(netbsd32_osethostname) },/* 88 = compat_43_netbsd32_osethostname */
	{ 0, 0, 0,
	    (sy_call_t *)compat_43(sys_getdtablesize) },/* 89 = compat_43_ogetdtablesize */
	{ ns(struct netbsd32_dup2_args), 0,
	    (sy_call_t *)netbsd32_dup2 },	/* 90 = netbsd32_dup2 */
	{ 0, 0, 0,
	    sys_nosys },			/* 91 = unimplemented getdopt */
	{ ns(struct netbsd32_fcntl_args), 0,
	    (sy_call_t *)netbsd32_fcntl },	/* 92 = netbsd32_fcntl */
	{ ns(struct compat_50_netbsd32_select_args), 0,
	    (sy_call_t *)compat_50(netbsd32_select) },/* 93 = compat_50_netbsd32_select */
	{ 0, 0, 0,
	    sys_nosys },			/* 94 = unimplemented setdopt */
	{ ns(struct netbsd32_fsync_args), 0,
	    (sy_call_t *)netbsd32_fsync },	/* 95 = netbsd32_fsync */
	{ ns(struct netbsd32_setpriority_args), 0,
	    (sy_call_t *)netbsd32_setpriority },/* 96 = netbsd32_setpriority */
	{ ns(struct compat_30_netbsd32_socket_args), 0,
	    (sy_call_t *)compat_30(netbsd32_socket) },/* 97 = compat_30_netbsd32_socket */
	{ ns(struct netbsd32_connect_args), 0,
	    (sy_call_t *)netbsd32_connect },	/* 98 = netbsd32_connect */
	{ ns(struct compat_43_netbsd32_oaccept_args), 0,
	    (sy_call_t *)compat_43(netbsd32_oaccept) },/* 99 = compat_43_netbsd32_oaccept */
	{ ns(struct netbsd32_getpriority_args), 0,
	    (sy_call_t *)netbsd32_getpriority },/* 100 = netbsd32_getpriority */
	{ ns(struct compat_43_netbsd32_osend_args), 0,
	    (sy_call_t *)compat_43(netbsd32_osend) },/* 101 = compat_43_netbsd32_osend */
	{ ns(struct compat_43_netbsd32_orecv_args), 0,
	    (sy_call_t *)compat_43(netbsd32_orecv) },/* 102 = compat_43_netbsd32_orecv */
	{ ns(struct compat_13_netbsd32_sigreturn_args), 0,
	    (sy_call_t *)compat_13(netbsd32_sigreturn) },/* 103 = compat_13_sigreturn13 */
	{ ns(struct netbsd32_bind_args), 0,
	    (sy_call_t *)netbsd32_bind },	/* 104 = netbsd32_bind */
	{ ns(struct netbsd32_setsockopt_args), 0,
	    (sy_call_t *)netbsd32_setsockopt },	/* 105 = netbsd32_setsockopt */
	{ ns(struct netbsd32_listen_args), 0,
	    (sy_call_t *)netbsd32_listen },	/* 106 = netbsd32_listen */
	{ 0, 0, 0,
	    sys_nosys },			/* 107 = obsolete vtimes */
	{ ns(struct compat_43_netbsd32_osigvec_args), 0,
	    (sy_call_t *)compat_43(netbsd32_osigvec) },/* 108 = compat_43_netbsd32_osigvec */
	{ ns(struct compat_43_netbsd32_sigblock_args), 0,
	    (sy_call_t *)compat_43(netbsd32_sigblock) },/* 109 = compat_43_netbsd32_sigblock */
	{ ns(struct compat_43_netbsd32_sigsetmask_args), 0,
	    (sy_call_t *)compat_43(netbsd32_sigsetmask) },/* 110 = compat_43_netbsd32_sigsetmask */
	{ ns(struct compat_13_netbsd32_sigsuspend_args), 0,
	    (sy_call_t *)compat_13(netbsd32_sigsuspend) },/* 111 = compat_13_sigsuspend13 */
	{ ns(struct compat_43_netbsd32_osigstack_args), 0,
	    (sy_call_t *)compat_43(netbsd32_osigstack) },/* 112 = compat_43_netbsd32_osigstack */
	{ ns(struct compat_43_netbsd32_orecvmsg_args), 0,
	    (sy_call_t *)compat_43(netbsd32_orecvmsg) },/* 113 = compat_43_netbsd32_orecvmsg */
	{ ns(struct compat_43_netbsd32_osendmsg_args), 0,
	    (sy_call_t *)compat_43(netbsd32_osendmsg) },/* 114 = compat_43_netbsd32_osendmsg */
	{ 0, 0, 0,
	    sys_nosys },			/* 115 = obsolete vtrace */
	{ ns(struct compat_50_netbsd32_gettimeofday_args), 0,
	    (sy_call_t *)compat_50(netbsd32_gettimeofday) },/* 116 = compat_50_netbsd32_gettimeofday */
	{ ns(struct compat_50_netbsd32_getrusage_args), 0,
	    (sy_call_t *)compat_50(netbsd32_getrusage) },/* 117 = compat_50_netbsd32_getrusage */
	{ ns(struct netbsd32_getsockopt_args), 0,
	    (sy_call_t *)netbsd32_getsockopt },	/* 118 = netbsd32_getsockopt */
	{ 0, 0, 0,
	    sys_nosys },			/* 119 = obsolete resuba */
	{ ns(struct netbsd32_readv_args), 0,
	    (sy_call_t *)netbsd32_readv },	/* 120 = netbsd32_readv */
	{ ns(struct netbsd32_writev_args), 0,
	    (sy_call_t *)netbsd32_writev },	/* 121 = netbsd32_writev */
	{ ns(struct compat_50_netbsd32_settimeofday_args), 0,
	    (sy_call_t *)compat_50(netbsd32_settimeofday) },/* 122 = compat_50_netbsd32_settimeofday */
	{ ns(struct netbsd32_fchown_args), 0,
	    (sy_call_t *)netbsd32_fchown },	/* 123 = netbsd32_fchown */
	{ ns(struct netbsd32_fchmod_args), 0,
	    (sy_call_t *)netbsd32_fchmod },	/* 124 = netbsd32_fchmod */
	{ ns(struct compat_43_netbsd32_orecvfrom_args), 0,
	    (sy_call_t *)compat_43(netbsd32_orecvfrom) },/* 125 = compat_43_netbsd32_orecvfrom */
	{ ns(struct netbsd32_setreuid_args), 0,
	    (sy_call_t *)netbsd32_setreuid },	/* 126 = netbsd32_setreuid */
	{ ns(struct netbsd32_setregid_args), 0,
	    (sy_call_t *)netbsd32_setregid },	/* 127 = netbsd32_setregid */
	{ ns(struct netbsd32_rename_args), 0,
	    (sy_call_t *)netbsd32_rename },	/* 128 = netbsd32_rename */
	{ ns(struct compat_43_netbsd32_otruncate_args), 0,
	    (sy_call_t *)compat_43(netbsd32_otruncate) },/* 129 = compat_43_netbsd32_otruncate */
	{ ns(struct compat_43_netbsd32_oftruncate_args), 0,
	    (sy_call_t *)compat_43(netbsd32_oftruncate) },/* 130 = compat_43_netbsd32_oftruncate */
	{ ns(struct netbsd32_flock_args), 0,
	    (sy_call_t *)netbsd32_flock },	/* 131 = netbsd32_flock */
	{ ns(struct netbsd32_mkfifo_args), 0,
	    (sy_call_t *)netbsd32_mkfifo },	/* 132 = netbsd32_mkfifo */
	{ ns(struct netbsd32_sendto_args), 0,
	    (sy_call_t *)netbsd32_sendto },	/* 133 = netbsd32_sendto */
	{ ns(struct netbsd32_shutdown_args), 0,
	    (sy_call_t *)netbsd32_shutdown },	/* 134 = netbsd32_shutdown */
	{ ns(struct netbsd32_socketpair_args), 0,
	    (sy_call_t *)netbsd32_socketpair },	/* 135 = netbsd32_socketpair */
	{ ns(struct netbsd32_mkdir_args), 0,
	    (sy_call_t *)netbsd32_mkdir },	/* 136 = netbsd32_mkdir */
	{ ns(struct netbsd32_rmdir_args), 0,
	    (sy_call_t *)netbsd32_rmdir },	/* 137 = netbsd32_rmdir */
	{ ns(struct compat_50_netbsd32_utimes_args), 0,
	    (sy_call_t *)compat_50(netbsd32_utimes) },/* 138 = compat_50_netbsd32_utimes */
	{ 0, 0, 0,
	    sys_nosys },			/* 139 = obsolete 4.2 sigreturn */
	{ ns(struct compat_50_netbsd32_adjtime_args), 0,
	    (sy_call_t *)compat_50(netbsd32_adjtime) },/* 140 = compat_50_netbsd32_adjtime */
	{ ns(struct compat_43_netbsd32_ogetpeername_args), 0,
	    (sy_call_t *)compat_43(netbsd32_ogetpeername) },/* 141 = compat_43_netbsd32_ogetpeername */
	{ 0, 0, 0,
	    (sy_call_t *)compat_43(sys_gethostid) },/* 142 = compat_43_ogethostid */
	{ ns(struct compat_43_netbsd32_sethostid_args), 0,
	    (sy_call_t *)compat_43(netbsd32_sethostid) },/* 143 = compat_43_netbsd32_sethostid */
	{ ns(struct compat_43_netbsd32_ogetrlimit_args), 0,
	    (sy_call_t *)compat_43(netbsd32_ogetrlimit) },/* 144 = compat_43_netbsd32_ogetrlimit */
	{ ns(struct compat_43_netbsd32_osetrlimit_args), 0,
	    (sy_call_t *)compat_43(netbsd32_osetrlimit) },/* 145 = compat_43_netbsd32_osetrlimit */
	{ ns(struct compat_43_netbsd32_killpg_args), 0,
	    (sy_call_t *)compat_43(netbsd32_killpg) },/* 146 = compat_43_netbsd32_killpg */
	{ 0, 0, 0,
	    (sy_call_t *)sys_setsid },		/* 147 = setsid */
	{ ns(struct netbsd32_quotactl_args), 0,
	    (sy_call_t *)netbsd32_quotactl },	/* 148 = netbsd32_quotactl */
	{ 0, 0, 0,
	    (sy_call_t *)compat_43(sys_quota) },/* 149 = compat_43_oquota */
	{ ns(struct compat_43_netbsd32_ogetsockname_args), 0,
	    (sy_call_t *)compat_43(netbsd32_ogetsockname) },/* 150 = compat_43_netbsd32_ogetsockname */
	{ 0, 0, 0,
	    sys_nosys },			/* 151 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 152 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 153 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 154 = unimplemented */
	{ ns(struct netbsd32_nfssvc_args), 0,
	    (sy_call_t *)netbsd32_nfssvc },	/* 155 = netbsd32_nfssvc */
	{ ns(struct compat_43_netbsd32_ogetdirentries_args), 0,
	    (sy_call_t *)compat_43(netbsd32_ogetdirentries) },/* 156 = compat_43_netbsd32_ogetdirentries */
	{ ns(struct compat_20_netbsd32_statfs_args), 0,
	    (sy_call_t *)compat_20(netbsd32_statfs) },/* 157 = compat_20_netbsd32_statfs */
	{ ns(struct compat_20_netbsd32_fstatfs_args), 0,
	    (sy_call_t *)compat_20(netbsd32_fstatfs) },/* 158 = compat_20_netbsd32_fstatfs */
	{ 0, 0, 0,
	    sys_nosys },			/* 159 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 160 = unimplemented */
	{ ns(struct compat_30_netbsd32_getfh_args), 0,
	    (sy_call_t *)compat_30(netbsd32_getfh) },/* 161 = compat_30_netbsd32_getfh */
	{ ns(struct compat_09_netbsd32_ogetdomainname_args), 0,
	    (sy_call_t *)compat_09(netbsd32_ogetdomainname) },/* 162 = compat_09_netbsd32_ogetdomainname */
	{ ns(struct compat_09_netbsd32_osetdomainname_args), 0,
	    (sy_call_t *)compat_09(netbsd32_osetdomainname) },/* 163 = compat_09_netbsd32_osetdomainname */
	{ ns(struct compat_09_netbsd32_uname_args), 0,
	    (sy_call_t *)compat_09(netbsd32_uname) },/* 164 = compat_09_netbsd32_uname */
	{ ns(struct netbsd32_sysarch_args), 0,
	    (sy_call_t *)netbsd32_sysarch },	/* 165 = netbsd32_sysarch */
	{ 0, 0, 0,
	    sys_nosys },			/* 166 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 167 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 168 = unimplemented */
#if defined(SYSVSEM) || !defined(_KERNEL_OPT)
	{ ns(struct compat_10_netbsd32_semsys_args), 0,
	    (sy_call_t *)compat_10(netbsd32_semsys) },/* 169 = compat_10_osemsys */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 169 = excluded netbsd32_semsys */
#endif
#if defined(SYSVMSG) || !defined(_KERNEL_OPT)
	{ ns(struct compat_10_netbsd32_msgsys_args), 0,
	    (sy_call_t *)compat_10(netbsd32_msgsys) },/* 170 = compat_10_omsgsys */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 170 = excluded netbsd32_msgsys */
#endif
#if defined(SYSVSHM) || !defined(_KERNEL_OPT)
	{ ns(struct compat_10_netbsd32_shmsys_args), 0,
	    (sy_call_t *)compat_10(netbsd32_shmsys) },/* 171 = compat_10_oshmsys */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 171 = excluded netbsd32_shmsys */
#endif
	{ 0, 0, 0,
	    sys_nosys },			/* 172 = unimplemented */
	{ ns(struct netbsd32_pread_args), 0,
	    (sy_call_t *)netbsd32_pread },	/* 173 = netbsd32_pread */
	{ ns(struct netbsd32_pwrite_args), 0,
	    (sy_call_t *)netbsd32_pwrite },	/* 174 = netbsd32_pwrite */
#if defined(NTP) || !defined(_KERNEL_OPT)
	{ ns(struct compat_30_netbsd32_ntp_gettime_args), 0,
	    (sy_call_t *)compat_30(netbsd32_ntp_gettime) },/* 175 = compat_30_netbsd32_ntp_gettime */
	{ ns(struct netbsd32_ntp_adjtime_args), 0,
	    (sy_call_t *)netbsd32_ntp_adjtime },/* 176 = netbsd32_ntp_adjtime */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 175 = excluded ntp_gettime */
	{ 0, 0, 0,
	    sys_nosys },			/* 176 = excluded ntp_adjtime */
#endif
	{ 0, 0, 0,
	    sys_nosys },			/* 177 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 178 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 179 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 180 = unimplemented */
	{ ns(struct netbsd32_setgid_args), 0,
	    (sy_call_t *)netbsd32_setgid },	/* 181 = netbsd32_setgid */
	{ ns(struct netbsd32_setegid_args), 0,
	    (sy_call_t *)netbsd32_setegid },	/* 182 = netbsd32_setegid */
	{ ns(struct netbsd32_seteuid_args), 0,
	    (sy_call_t *)netbsd32_seteuid },	/* 183 = netbsd32_seteuid */
#if defined(LFS) || !defined(_KERNEL_OPT)
	{ ns(struct netbsd32_lfs_bmapv_args), 0,
	    (sy_call_t *)netbsd32_lfs_bmapv },	/* 184 = netbsd32_lfs_bmapv */
	{ ns(struct netbsd32_lfs_markv_args), 0,
	    (sy_call_t *)netbsd32_lfs_markv },	/* 185 = netbsd32_lfs_markv */
	{ ns(struct netbsd32_lfs_segclean_args), 0,
	    (sy_call_t *)netbsd32_lfs_segclean },/* 186 = netbsd32_lfs_segclean */
	{ ns(struct compat_50_netbsd32_lfs_segwait_args), 0,
	    (sy_call_t *)compat_50(netbsd32_lfs_segwait) },/* 187 = compat_50_netbsd32_lfs_segwait */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 184 = excluded netbsd32_lfs_bmapv */
	{ 0, 0, 0,
	    sys_nosys },			/* 185 = excluded netbsd32_lfs_markv */
	{ 0, 0, 0,
	    sys_nosys },			/* 186 = excluded netbsd32_lfs_segclean */
	{ 0, 0, 0,
	    sys_nosys },			/* 187 = excluded netbsd32_lfs_segwait */
#endif
	{ ns(struct compat_12_netbsd32_stat12_args), 0,
	    (sy_call_t *)compat_12(netbsd32_stat12) },/* 188 = compat_12_netbsd32_stat12 */
	{ ns(struct compat_12_netbsd32_fstat12_args), 0,
	    (sy_call_t *)compat_12(netbsd32_fstat12) },/* 189 = compat_12_netbsd32_fstat12 */
	{ ns(struct compat_12_netbsd32_lstat12_args), 0,
	    (sy_call_t *)compat_12(netbsd32_lstat12) },/* 190 = compat_12_netbsd32_lstat12 */
	{ ns(struct netbsd32_pathconf_args), 0,
	    (sy_call_t *)netbsd32_pathconf },	/* 191 = netbsd32_pathconf */
	{ ns(struct netbsd32_fpathconf_args), 0,
	    (sy_call_t *)netbsd32_fpathconf },	/* 192 = netbsd32_fpathconf */
	{ 0, 0, 0,
	    sys_nosys },			/* 193 = unimplemented */
	{ ns(struct netbsd32_getrlimit_args), 0,
	    (sy_call_t *)netbsd32_getrlimit },	/* 194 = netbsd32_getrlimit */
	{ ns(struct netbsd32_setrlimit_args), 0,
	    (sy_call_t *)netbsd32_setrlimit },	/* 195 = netbsd32_setrlimit */
	{ ns(struct compat_12_netbsd32_getdirentries_args), 0,
	    (sy_call_t *)compat_12(netbsd32_getdirentries) },/* 196 = compat_12_netbsd32_getdirentries */
	{ ns(struct netbsd32_mmap_args), 0,
	    (sy_call_t *)netbsd32_mmap },	/* 197 = netbsd32_mmap */
	{ ns(struct netbsd32____syscall_args), SYCALL_INDIRECT,
	    (sy_call_t *)netbsd32____syscall },	/* 198 = netbsd32____syscall */
	{ ns(struct netbsd32_lseek_args), 0,
	    (sy_call_t *)netbsd32_lseek },	/* 199 = netbsd32_lseek */
	{ ns(struct netbsd32_truncate_args), 0,
	    (sy_call_t *)netbsd32_truncate },	/* 200 = netbsd32_truncate */
	{ ns(struct netbsd32_ftruncate_args), 0,
	    (sy_call_t *)netbsd32_ftruncate },	/* 201 = netbsd32_ftruncate */
	{ ns(struct netbsd32___sysctl_args), 0,
	    (sy_call_t *)netbsd32___sysctl },	/* 202 = netbsd32___sysctl */
	{ ns(struct netbsd32_mlock_args), 0,
	    (sy_call_t *)netbsd32_mlock },	/* 203 = netbsd32_mlock */
	{ ns(struct netbsd32_munlock_args), 0,
	    (sy_call_t *)netbsd32_munlock },	/* 204 = netbsd32_munlock */
	{ ns(struct netbsd32_undelete_args), 0,
	    (sy_call_t *)netbsd32_undelete },	/* 205 = netbsd32_undelete */
	{ ns(struct compat_50_netbsd32_futimes_args), 0,
	    (sy_call_t *)compat_50(netbsd32_futimes) },/* 206 = compat_50_netbsd32_futimes */
	{ ns(struct netbsd32_getpgid_args), 0,
	    (sy_call_t *)netbsd32_getpgid },	/* 207 = netbsd32_getpgid */
	{ ns(struct netbsd32_reboot_args), 0,
	    (sy_call_t *)netbsd32_reboot },	/* 208 = netbsd32_reboot */
	{ ns(struct netbsd32_poll_args), 0,
	    (sy_call_t *)netbsd32_poll },	/* 209 = netbsd32_poll */
	{ 0, 0, 0,
	    sys_nosys },			/* 210 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 211 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 212 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 213 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 214 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 215 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 216 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 217 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 218 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 219 = unimplemented */
#if defined(SYSVSEM) || !defined(_KERNEL_OPT)
	{ ns(struct compat_14_netbsd32___semctl_args), 0,
	    (sy_call_t *)compat_14(netbsd32___semctl) },/* 220 = compat_14_netbsd32___semctl */
	{ ns(struct netbsd32_semget_args), 0,
	    (sy_call_t *)netbsd32_semget },	/* 221 = netbsd32_semget */
	{ ns(struct netbsd32_semop_args), 0,
	    (sy_call_t *)netbsd32_semop },	/* 222 = netbsd32_semop */
	{ ns(struct netbsd32_semconfig_args), 0,
	    (sy_call_t *)netbsd32_semconfig },	/* 223 = netbsd32_semconfig */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 220 = excluded compat_14_netbsd32_semctl */
	{ 0, 0, 0,
	    sys_nosys },			/* 221 = excluded netbsd32_semget */
	{ 0, 0, 0,
	    sys_nosys },			/* 222 = excluded netbsd32_semop */
	{ 0, 0, 0,
	    sys_nosys },			/* 223 = excluded netbsd32_semconfig */
#endif
#if defined(SYSVMSG) || !defined(_KERNEL_OPT)
	{ ns(struct compat_14_netbsd32_msgctl_args), 0,
	    (sy_call_t *)compat_14(netbsd32_msgctl) },/* 224 = compat_14_netbsd32_msgctl */
	{ ns(struct netbsd32_msgget_args), 0,
	    (sy_call_t *)netbsd32_msgget },	/* 225 = netbsd32_msgget */
	{ ns(struct netbsd32_msgsnd_args), 0,
	    (sy_call_t *)netbsd32_msgsnd },	/* 226 = netbsd32_msgsnd */
	{ ns(struct netbsd32_msgrcv_args), 0,
	    (sy_call_t *)netbsd32_msgrcv },	/* 227 = netbsd32_msgrcv */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 224 = excluded compat_14_netbsd32_msgctl */
	{ 0, 0, 0,
	    sys_nosys },			/* 225 = excluded netbsd32_msgget */
	{ 0, 0, 0,
	    sys_nosys },			/* 226 = excluded netbsd32_msgsnd */
	{ 0, 0, 0,
	    sys_nosys },			/* 227 = excluded netbsd32_msgrcv */
#endif
#if defined(SYSVSHM) || !defined(_KERNEL_OPT)
	{ ns(struct netbsd32_shmat_args), 0,
	    (sy_call_t *)netbsd32_shmat },	/* 228 = netbsd32_shmat */
	{ ns(struct compat_14_netbsd32_shmctl_args), 0,
	    (sy_call_t *)compat_14(netbsd32_shmctl) },/* 229 = compat_14_netbsd32_shmctl */
	{ ns(struct netbsd32_shmdt_args), 0,
	    (sy_call_t *)netbsd32_shmdt },	/* 230 = netbsd32_shmdt */
	{ ns(struct netbsd32_shmget_args), 0,
	    (sy_call_t *)netbsd32_shmget },	/* 231 = netbsd32_shmget */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 228 = excluded netbsd32_shmat */
	{ 0, 0, 0,
	    sys_nosys },			/* 229 = excluded compat_14_netbsd32_shmctl */
	{ 0, 0, 0,
	    sys_nosys },			/* 230 = excluded netbsd32_shmdt */
	{ 0, 0, 0,
	    sys_nosys },			/* 231 = excluded netbsd32_shmget */
#endif
	{ ns(struct compat_50_netbsd32_clock_gettime_args), 0,
	    (sy_call_t *)compat_50(netbsd32_clock_gettime) },/* 232 = compat_50_netbsd32_clock_gettime */
	{ ns(struct compat_50_netbsd32_clock_settime_args), 0,
	    (sy_call_t *)compat_50(netbsd32_clock_settime) },/* 233 = compat_50_netbsd32_clock_settime */
	{ ns(struct compat_50_netbsd32_clock_getres_args), 0,
	    (sy_call_t *)compat_50(netbsd32_clock_getres) },/* 234 = compat_50_netbsd32_clock_getres */
	{ ns(struct netbsd32_timer_create_args), 0,
	    (sy_call_t *)netbsd32_timer_create },/* 235 = netbsd32_timer_create */
	{ ns(struct netbsd32_timer_delete_args), 0,
	    (sy_call_t *)netbsd32_timer_delete },/* 236 = netbsd32_timer_delete */
	{ ns(struct compat_50_netbsd32_timer_settime_args), 0,
	    (sy_call_t *)compat_50(netbsd32_timer_settime) },/* 237 = compat_50_netbsd32_timer_settime */
	{ ns(struct compat_50_netbsd32_timer_gettime_args), 0,
	    (sy_call_t *)compat_50(netbsd32_timer_gettime) },/* 238 = compat_50_netbsd32_timer_gettime */
	{ ns(struct netbsd32_timer_getoverrun_args), 0,
	    (sy_call_t *)netbsd32_timer_getoverrun },/* 239 = netbsd32_timer_getoverrun */
	{ ns(struct compat_50_netbsd32_nanosleep_args), 0,
	    (sy_call_t *)compat_50(netbsd32_nanosleep) },/* 240 = compat_50_netbsd32_nanosleep */
	{ ns(struct netbsd32_fdatasync_args), 0,
	    (sy_call_t *)netbsd32_fdatasync },	/* 241 = netbsd32_fdatasync */
	{ ns(struct netbsd32_mlockall_args), 0,
	    (sy_call_t *)netbsd32_mlockall },	/* 242 = netbsd32_mlockall */
	{ 0, 0, 0,
	    (sy_call_t *)sys_munlockall },	/* 243 = munlockall */
	{ ns(struct compat_50_netbsd32___sigtimedwait_args), 0,
	    (sy_call_t *)compat_50(netbsd32___sigtimedwait) },/* 244 = compat_50_netbsd32___sigtimedwait */
	{ 0, 0, 0,
	    sys_nosys },			/* 245 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 246 = unimplemented */
#if defined(P1003_1B_SEMAPHORE) || (!defined(_KERNEL_OPT) && defined(_LIBC))
	{ ns(struct netbsd32__ksem_init_args), 0,
	    (sy_call_t *)netbsd32__ksem_init },	/* 247 = netbsd32__ksem_init */
	{ ns(struct netbsd32__ksem_open_args), 0,
	    (sy_call_t *)netbsd32__ksem_open },	/* 248 = netbsd32__ksem_open */
	{ ns(struct netbsd32__ksem_unlink_args), 0,
	    (sy_call_t *)netbsd32__ksem_unlink },/* 249 = netbsd32__ksem_unlink */
	{ ns(struct netbsd32__ksem_close_args), 0,
	    (sy_call_t *)netbsd32__ksem_close },/* 250 = netbsd32__ksem_close */
	{ ns(struct netbsd32__ksem_post_args), 0,
	    (sy_call_t *)netbsd32__ksem_post },	/* 251 = netbsd32__ksem_post */
	{ ns(struct netbsd32__ksem_wait_args), 0,
	    (sy_call_t *)netbsd32__ksem_wait },	/* 252 = netbsd32__ksem_wait */
	{ ns(struct netbsd32__ksem_trywait_args), 0,
	    (sy_call_t *)netbsd32__ksem_trywait },/* 253 = netbsd32__ksem_trywait */
	{ ns(struct netbsd32__ksem_getvalue_args), 0,
	    (sy_call_t *)netbsd32__ksem_getvalue },/* 254 = netbsd32__ksem_getvalue */
	{ ns(struct netbsd32__ksem_destroy_args), 0,
	    (sy_call_t *)netbsd32__ksem_destroy },/* 255 = netbsd32__ksem_destroy */
	{ 0, 0, 0,
	    sys_nosys },			/* 256 = unimplemented sys__ksem_timedwait */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 247 = excluded sys__ksem_init */
	{ 0, 0, 0,
	    sys_nosys },			/* 248 = excluded sys__ksem_open */
	{ 0, 0, 0,
	    sys_nosys },			/* 249 = excluded sys__ksem_unlink */
	{ 0, 0, 0,
	    sys_nosys },			/* 250 = excluded sys__ksem_close */
	{ 0, 0, 0,
	    sys_nosys },			/* 251 = excluded sys__ksem_post */
	{ 0, 0, 0,
	    sys_nosys },			/* 252 = excluded sys__ksem_wait */
	{ 0, 0, 0,
	    sys_nosys },			/* 253 = excluded sys__ksem_trywait */
	{ 0, 0, 0,
	    sys_nosys },			/* 254 = excluded sys__ksem_getvalue */
	{ 0, 0, 0,
	    sys_nosys },			/* 255 = excluded sys__ksem_destroy */
	{ 0, 0, 0,
	    sys_nosys },			/* 256 = unimplemented sys__ksem_timedwait */
#endif
	{ 0, 0, 0,
	    sys_nosys },			/* 257 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 258 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 259 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 260 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 261 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 262 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 263 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 264 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 265 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 266 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 267 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 268 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 269 = unimplemented */
	{ ns(struct netbsd32___posix_rename_args), 0,
	    (sy_call_t *)netbsd32___posix_rename },/* 270 = netbsd32___posix_rename */
	{ ns(struct netbsd32_swapctl_args), 0,
	    (sy_call_t *)netbsd32_swapctl },	/* 271 = netbsd32_swapctl */
	{ ns(struct compat_30_netbsd32_getdents_args), 0,
	    (sy_call_t *)compat_30(netbsd32_getdents) },/* 272 = compat_30_netbsd32_getdents */
	{ ns(struct netbsd32_minherit_args), 0,
	    (sy_call_t *)netbsd32_minherit },	/* 273 = netbsd32_minherit */
	{ ns(struct netbsd32_lchmod_args), 0,
	    (sy_call_t *)netbsd32_lchmod },	/* 274 = netbsd32_lchmod */
	{ ns(struct netbsd32_lchown_args), 0,
	    (sy_call_t *)netbsd32_lchown },	/* 275 = netbsd32_lchown */
	{ ns(struct compat_50_netbsd32_lutimes_args), 0,
	    (sy_call_t *)compat_50(netbsd32_lutimes) },/* 276 = compat_50_netbsd32_lutimes */
	{ ns(struct netbsd32___msync13_args), 0,
	    (sy_call_t *)netbsd32___msync13 },	/* 277 = netbsd32___msync13 */
	{ ns(struct compat_30_netbsd32___stat13_args), 0,
	    (sy_call_t *)compat_30(netbsd32___stat13) },/* 278 = compat_30_netbsd32___stat13 */
	{ ns(struct compat_30_netbsd32___fstat13_args), 0,
	    (sy_call_t *)compat_30(netbsd32___fstat13) },/* 279 = compat_30_netbsd32___fstat13 */
	{ ns(struct compat_30_netbsd32___lstat13_args), 0,
	    (sy_call_t *)compat_30(netbsd32___lstat13) },/* 280 = compat_30_netbsd32___lstat13 */
	{ ns(struct netbsd32___sigaltstack14_args), 0,
	    (sy_call_t *)netbsd32___sigaltstack14 },/* 281 = netbsd32___sigaltstack14 */
	{ 0, 0, 0,
	    (sy_call_t *)sys___vfork14 },	/* 282 = __vfork14 */
	{ ns(struct netbsd32___posix_chown_args), 0,
	    (sy_call_t *)netbsd32___posix_chown },/* 283 = netbsd32___posix_chown */
	{ ns(struct netbsd32___posix_fchown_args), 0,
	    (sy_call_t *)netbsd32___posix_fchown },/* 284 = netbsd32___posix_fchown */
	{ ns(struct netbsd32___posix_lchown_args), 0,
	    (sy_call_t *)netbsd32___posix_lchown },/* 285 = netbsd32___posix_lchown */
	{ ns(struct netbsd32_getsid_args), 0,
	    (sy_call_t *)netbsd32_getsid },	/* 286 = netbsd32_getsid */
	{ ns(struct netbsd32___clone_args), 0,
	    (sy_call_t *)netbsd32___clone },	/* 287 = netbsd32___clone */
	{ ns(struct netbsd32_fktrace_args), 0,
	    (sy_call_t *)netbsd32_fktrace },	/* 288 = netbsd32_fktrace */
	{ ns(struct netbsd32_preadv_args), 0,
	    (sy_call_t *)netbsd32_preadv },	/* 289 = netbsd32_preadv */
	{ ns(struct netbsd32_pwritev_args), 0,
	    (sy_call_t *)netbsd32_pwritev },	/* 290 = netbsd32_pwritev */
	{ ns(struct netbsd32___sigaction14_args), 0,
	    (sy_call_t *)netbsd32___sigaction14 },/* 291 = netbsd32___sigaction14 */
	{ ns(struct netbsd32___sigpending14_args), 0,
	    (sy_call_t *)netbsd32___sigpending14 },/* 292 = netbsd32___sigpending14 */
	{ ns(struct netbsd32___sigprocmask14_args), 0,
	    (sy_call_t *)netbsd32___sigprocmask14 },/* 293 = netbsd32___sigprocmask14 */
	{ ns(struct netbsd32___sigsuspend14_args), 0,
	    (sy_call_t *)netbsd32___sigsuspend14 },/* 294 = netbsd32___sigsuspend14 */
	{ ns(struct compat_16_netbsd32___sigreturn14_args), 0,
	    (sy_call_t *)compat_16(netbsd32___sigreturn14) },/* 295 = compat_16_netbsd32___sigreturn14 */
	{ ns(struct netbsd32___getcwd_args), 0,
	    (sy_call_t *)netbsd32___getcwd },	/* 296 = netbsd32___getcwd */
	{ ns(struct netbsd32_fchroot_args), 0,
	    (sy_call_t *)netbsd32_fchroot },	/* 297 = netbsd32_fchroot */
	{ ns(struct compat_30_netbsd32_fhopen_args), 0,
	    (sy_call_t *)compat_30(netbsd32_fhopen) },/* 298 = compat_30_netbsd32_fhopen */
	{ ns(struct compat_30_netbsd32_fhstat_args), 0,
	    (sy_call_t *)compat_30(netbsd32_fhstat) },/* 299 = compat_30_netbsd32_fhstat */
	{ ns(struct compat_20_netbsd32_fhstatfs_args), 0,
	    (sy_call_t *)compat_20(netbsd32_fhstatfs) },/* 300 = compat_20_netbsd32_fhstatfs */
#if defined(SYSVSEM) || !defined(_KERNEL_OPT)
	{ ns(struct compat_50_netbsd32___semctl14_args), 0,
	    (sy_call_t *)compat_50(netbsd32___semctl14) },/* 301 = compat_50_netbsd32___semctl14 */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 301 = excluded __semctl14 */
#endif
#if defined(SYSVMSG) || !defined(_KERNEL_OPT)
	{ ns(struct compat_50_netbsd32___msgctl13_args), 0,
	    (sy_call_t *)compat_50(netbsd32___msgctl13) },/* 302 = compat_50_netbsd32___msgctl13 */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 302 = excluded __msgctl13 */
#endif
#if defined(SYSVSHM) || !defined(_KERNEL_OPT)
	{ ns(struct compat_50_netbsd32___shmctl13_args), 0,
	    (sy_call_t *)compat_50(netbsd32___shmctl13) },/* 303 = compat_50_netbsd32___shmctl13 */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 303 = excluded __shmctl13 */
#endif
	{ ns(struct netbsd32_lchflags_args), 0,
	    (sy_call_t *)netbsd32_lchflags },	/* 304 = netbsd32_lchflags */
	{ 0, 0, 0,
	    (sy_call_t *)sys_issetugid },	/* 305 = issetugid */
	{ ns(struct netbsd32_utrace_args), 0,
	    (sy_call_t *)netbsd32_utrace },	/* 306 = netbsd32_utrace */
	{ ns(struct netbsd32_getcontext_args), 0,
	    (sy_call_t *)netbsd32_getcontext },	/* 307 = netbsd32_getcontext */
	{ ns(struct netbsd32_setcontext_args), 0,
	    (sy_call_t *)netbsd32_setcontext },	/* 308 = netbsd32_setcontext */
	{ ns(struct netbsd32__lwp_create_args), 0,
	    (sy_call_t *)netbsd32__lwp_create },/* 309 = netbsd32__lwp_create */
	{ 0, 0, 0,
	    (sy_call_t *)sys__lwp_exit },	/* 310 = _lwp_exit */
	{ 0, 0, 0,
	    (sy_call_t *)sys__lwp_self },	/* 311 = _lwp_self */
	{ ns(struct netbsd32__lwp_wait_args), 0,
	    (sy_call_t *)netbsd32__lwp_wait },	/* 312 = netbsd32__lwp_wait */
	{ ns(struct netbsd32__lwp_suspend_args), 0,
	    (sy_call_t *)netbsd32__lwp_suspend },/* 313 = netbsd32__lwp_suspend */
	{ ns(struct netbsd32__lwp_continue_args), 0,
	    (sy_call_t *)netbsd32__lwp_continue },/* 314 = netbsd32__lwp_continue */
	{ ns(struct netbsd32__lwp_wakeup_args), 0,
	    (sy_call_t *)netbsd32__lwp_wakeup },/* 315 = netbsd32__lwp_wakeup */
	{ 0, 0, 0,
	    (sy_call_t *)sys__lwp_getprivate },	/* 316 = _lwp_getprivate */
	{ ns(struct netbsd32__lwp_setprivate_args), 0,
	    (sy_call_t *)netbsd32__lwp_setprivate },/* 317 = netbsd32__lwp_setprivate */
	{ ns(struct netbsd32__lwp_kill_args), 0,
	    (sy_call_t *)netbsd32__lwp_kill },	/* 318 = netbsd32__lwp_kill */
	{ ns(struct netbsd32__lwp_detach_args), 0,
	    (sy_call_t *)netbsd32__lwp_detach },/* 319 = netbsd32__lwp_detach */
	{ ns(struct compat_50_netbsd32__lwp_park_args), 0,
	    (sy_call_t *)compat_50(netbsd32__lwp_park) },/* 320 = compat_50_netbsd32__lwp_park */
	{ ns(struct netbsd32__lwp_unpark_args), 0,
	    (sy_call_t *)netbsd32__lwp_unpark },/* 321 = netbsd32__lwp_unpark */
	{ ns(struct netbsd32__lwp_unpark_all_args), 0,
	    (sy_call_t *)netbsd32__lwp_unpark_all },/* 322 = netbsd32__lwp_unpark_all */
	{ ns(struct netbsd32__lwp_setname_args), 0,
	    (sy_call_t *)netbsd32__lwp_setname },/* 323 = netbsd32__lwp_setname */
	{ ns(struct netbsd32__lwp_getname_args), 0,
	    (sy_call_t *)netbsd32__lwp_getname },/* 324 = netbsd32__lwp_getname */
	{ ns(struct netbsd32__lwp_ctl_args), 0,
	    (sy_call_t *)netbsd32__lwp_ctl },	/* 325 = netbsd32__lwp_ctl */
	{ 0, 0, 0,
	    sys_nosys },			/* 326 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 327 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 328 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 329 = unimplemented */
	{ ns(struct netbsd32_sa_register_args), 0,
	    (sy_call_t *)netbsd32_sa_register },/* 330 = netbsd32_sa_register */
	{ ns(struct netbsd32_sa_stacks_args), 0,
	    (sy_call_t *)netbsd32_sa_stacks },	/* 331 = netbsd32_sa_stacks */
	{ 0, 0, 0,
	    (sy_call_t *)sys_sa_enable },	/* 332 = sa_enable */
	{ ns(struct netbsd32_sa_setconcurrency_args), 0,
	    (sy_call_t *)netbsd32_sa_setconcurrency },/* 333 = netbsd32_sa_setconcurrency */
	{ 0, 0, 0,
	    (sy_call_t *)sys_sa_yield },	/* 334 = sa_yield */
	{ ns(struct netbsd32_sa_preempt_args), 0,
	    (sy_call_t *)netbsd32_sa_preempt },	/* 335 = netbsd32_sa_preempt */
	{ 0, 0, 0,
	    sys_nosys },			/* 336 = obsolete sys_sa_unblockyield */
	{ 0, 0, 0,
	    sys_nosys },			/* 337 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 338 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 339 = unimplemented */
	{ ns(struct netbsd32___sigaction_sigtramp_args), 0,
	    (sy_call_t *)netbsd32___sigaction_sigtramp },/* 340 = netbsd32___sigaction_sigtramp */
	{ 0, 0, 0,
	    sys_nosys },			/* 341 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 342 = unimplemented */
	{ ns(struct netbsd32_rasctl_args), 0,
	    (sy_call_t *)netbsd32_rasctl },	/* 343 = netbsd32_rasctl */
	{ 0, 0, 0,
	    (sy_call_t *)sys_kqueue },		/* 344 = kqueue */
	{ ns(struct compat_50_netbsd32_kevent_args), 0,
	    (sy_call_t *)compat_50(netbsd32_kevent) },/* 345 = compat_50_netbsd32_kevent */
	{ ns(struct netbsd32__sched_setparam_args), 0,
	    (sy_call_t *)netbsd32__sched_setparam },/* 346 = netbsd32__sched_setparam */
	{ ns(struct netbsd32__sched_getparam_args), 0,
	    (sy_call_t *)netbsd32__sched_getparam },/* 347 = netbsd32__sched_getparam */
	{ ns(struct netbsd32__sched_setaffinity_args), 0,
	    (sy_call_t *)netbsd32__sched_setaffinity },/* 348 = netbsd32__sched_setaffinity */
	{ ns(struct netbsd32__sched_getaffinity_args), 0,
	    (sy_call_t *)netbsd32__sched_getaffinity },/* 349 = netbsd32__sched_getaffinity */
	{ 0, 0, 0,
	    (sy_call_t *)sys_sched_yield },	/* 350 = sched_yield */
	{ 0, 0, 0,
	    sys_nosys },			/* 351 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 352 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 353 = unimplemented */
	{ ns(struct netbsd32_fsync_range_args), 0,
	    (sy_call_t *)netbsd32_fsync_range },/* 354 = netbsd32_fsync_range */
	{ ns(struct netbsd32_uuidgen_args), 0,
	    (sy_call_t *)netbsd32_uuidgen },	/* 355 = netbsd32_uuidgen */
	{ ns(struct netbsd32_getvfsstat_args), 0,
	    (sy_call_t *)netbsd32_getvfsstat },	/* 356 = netbsd32_getvfsstat */
	{ ns(struct netbsd32_statvfs1_args), 0,
	    (sy_call_t *)netbsd32_statvfs1 },	/* 357 = netbsd32_statvfs1 */
	{ ns(struct netbsd32_fstatvfs1_args), 0,
	    (sy_call_t *)netbsd32_fstatvfs1 },	/* 358 = netbsd32_fstatvfs1 */
	{ ns(struct compat_30_netbsd32_fhstatvfs1_args), 0,
	    (sy_call_t *)compat_30(netbsd32_fhstatvfs1) },/* 359 = compat_30_netbsd32_fhstatvfs1 */
	{ ns(struct netbsd32_extattrctl_args), 0,
	    (sy_call_t *)netbsd32_extattrctl },	/* 360 = netbsd32_extattrctl */
	{ ns(struct netbsd32_extattr_set_file_args), 0,
	    (sy_call_t *)netbsd32_extattr_set_file },/* 361 = netbsd32_extattr_set_file */
	{ ns(struct netbsd32_extattr_get_file_args), 0,
	    (sy_call_t *)netbsd32_extattr_get_file },/* 362 = netbsd32_extattr_get_file */
	{ ns(struct netbsd32_extattr_delete_file_args), 0,
	    (sy_call_t *)netbsd32_extattr_delete_file },/* 363 = netbsd32_extattr_delete_file */
	{ ns(struct netbsd32_extattr_set_fd_args), 0,
	    (sy_call_t *)netbsd32_extattr_set_fd },/* 364 = netbsd32_extattr_set_fd */
	{ ns(struct netbsd32_extattr_get_fd_args), 0,
	    (sy_call_t *)netbsd32_extattr_get_fd },/* 365 = netbsd32_extattr_get_fd */
	{ ns(struct netbsd32_extattr_delete_fd_args), 0,
	    (sy_call_t *)netbsd32_extattr_delete_fd },/* 366 = netbsd32_extattr_delete_fd */
	{ ns(struct netbsd32_extattr_set_link_args), 0,
	    (sy_call_t *)netbsd32_extattr_set_link },/* 367 = netbsd32_extattr_set_link */
	{ ns(struct netbsd32_extattr_get_link_args), 0,
	    (sy_call_t *)netbsd32_extattr_get_link },/* 368 = netbsd32_extattr_get_link */
	{ ns(struct netbsd32_extattr_delete_link_args), 0,
	    (sy_call_t *)netbsd32_extattr_delete_link },/* 369 = netbsd32_extattr_delete_link */
	{ ns(struct netbsd32_extattr_list_fd_args), 0,
	    (sy_call_t *)netbsd32_extattr_list_fd },/* 370 = netbsd32_extattr_list_fd */
	{ ns(struct netbsd32_extattr_list_file_args), 0,
	    (sy_call_t *)netbsd32_extattr_list_file },/* 371 = netbsd32_extattr_list_file */
	{ ns(struct netbsd32_extattr_list_link_args), 0,
	    (sy_call_t *)netbsd32_extattr_list_link },/* 372 = netbsd32_extattr_list_link */
	{ ns(struct compat_50_netbsd32_pselect_args), 0,
	    (sy_call_t *)compat_50(netbsd32_pselect) },/* 373 = compat_50_netbsd32_pselect */
	{ ns(struct compat_50_netbsd32_pollts_args), 0,
	    (sy_call_t *)compat_50(netbsd32_pollts) },/* 374 = compat_50_netbsd32_pollts */
	{ ns(struct netbsd32_setxattr_args), 0,
	    (sy_call_t *)netbsd32_setxattr },	/* 375 = netbsd32_setxattr */
	{ ns(struct netbsd32_lsetxattr_args), 0,
	    (sy_call_t *)netbsd32_lsetxattr },	/* 376 = netbsd32_lsetxattr */
	{ ns(struct netbsd32_fsetxattr_args), 0,
	    (sy_call_t *)netbsd32_fsetxattr },	/* 377 = netbsd32_fsetxattr */
	{ ns(struct netbsd32_getxattr_args), 0,
	    (sy_call_t *)netbsd32_getxattr },	/* 378 = netbsd32_getxattr */
	{ ns(struct netbsd32_lgetxattr_args), 0,
	    (sy_call_t *)netbsd32_lgetxattr },	/* 379 = netbsd32_lgetxattr */
	{ ns(struct netbsd32_fgetxattr_args), 0,
	    (sy_call_t *)netbsd32_fgetxattr },	/* 380 = netbsd32_fgetxattr */
	{ ns(struct netbsd32_listxattr_args), 0,
	    (sy_call_t *)netbsd32_listxattr },	/* 381 = netbsd32_listxattr */
	{ ns(struct netbsd32_llistxattr_args), 0,
	    (sy_call_t *)netbsd32_llistxattr },	/* 382 = netbsd32_llistxattr */
	{ ns(struct netbsd32_flistxattr_args), 0,
	    (sy_call_t *)netbsd32_flistxattr },	/* 383 = netbsd32_flistxattr */
	{ ns(struct netbsd32_removexattr_args), 0,
	    (sy_call_t *)netbsd32_removexattr },/* 384 = netbsd32_removexattr */
	{ ns(struct netbsd32_lremovexattr_args), 0,
	    (sy_call_t *)netbsd32_lremovexattr },/* 385 = netbsd32_lremovexattr */
	{ ns(struct netbsd32_fremovexattr_args), 0,
	    (sy_call_t *)netbsd32_fremovexattr },/* 386 = netbsd32_fremovexattr */
	{ ns(struct compat_50_netbsd32___stat30_args), 0,
	    (sy_call_t *)compat_50(netbsd32___stat30) },/* 387 = compat_50_netbsd32___stat30 */
	{ ns(struct compat_50_netbsd32___fstat30_args), 0,
	    (sy_call_t *)compat_50(netbsd32___fstat30) },/* 388 = compat_50_netbsd32___fstat30 */
	{ ns(struct compat_50_netbsd32___lstat30_args), 0,
	    (sy_call_t *)compat_50(netbsd32___lstat30) },/* 389 = compat_50_netbsd32___lstat30 */
	{ ns(struct netbsd32___getdents30_args), 0,
	    (sy_call_t *)netbsd32___getdents30 },/* 390 = netbsd32___getdents30 */
	{ 0, 0, 0,
	    (sy_call_t *)nullop },			/* 391 = ignored old posix fadvise */
	{ ns(struct compat_30_netbsd32___fhstat30_args), 0,
	    (sy_call_t *)compat_30(netbsd32___fhstat30) },/* 392 = compat_30_netbsd32___fhstat30 */
#if defined(NTP) || !defined(_KERNEL_OPT)
	{ ns(struct compat_50_netbsd32_ntp_gettime_args), 0,
	    (sy_call_t *)compat_50(netbsd32_ntp_gettime) },/* 393 = compat_50_netbsd32_ntp_gettime */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 393 = excluded __ntp_gettime30 */
#endif
	{ ns(struct netbsd32___socket30_args), 0,
	    (sy_call_t *)netbsd32___socket30 },	/* 394 = netbsd32___socket30 */
	{ ns(struct netbsd32___getfh30_args), 0,
	    (sy_call_t *)netbsd32___getfh30 },	/* 395 = netbsd32___getfh30 */
	{ ns(struct netbsd32___fhopen40_args), 0,
	    (sy_call_t *)netbsd32___fhopen40 },	/* 396 = netbsd32___fhopen40 */
	{ ns(struct netbsd32___fhstatvfs140_args), 0,
	    (sy_call_t *)netbsd32___fhstatvfs140 },/* 397 = netbsd32___fhstatvfs140 */
	{ ns(struct compat_50_netbsd32___fhstat40_args), 0,
	    (sy_call_t *)compat_50(netbsd32___fhstat40) },/* 398 = compat_50_netbsd32___fhstat40 */
	{ 0, 0, 0,
	    sys_nosys },			/* 399 = unimplemented sys_aio_cancel */
	{ 0, 0, 0,
	    sys_nosys },			/* 400 = unimplemented sys_aio_error */
	{ 0, 0, 0,
	    sys_nosys },			/* 401 = unimplemented sys_aio_fsync */
	{ 0, 0, 0,
	    sys_nosys },			/* 402 = unimplemented sys_aio_read */
	{ 0, 0, 0,
	    sys_nosys },			/* 403 = unimplemented sys_aio_return */
	{ 0, 0, 0,
	    sys_nosys },			/* 404 = unimplemented sys_aio_suspend */
	{ 0, 0, 0,
	    sys_nosys },			/* 405 = unimplemented sys_aio_write */
	{ 0, 0, 0,
	    sys_nosys },			/* 406 = unimplemented sys_lio_listio */
	{ 0, 0, 0,
	    sys_nosys },			/* 407 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 408 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 409 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 410 = unimplemented sys___mount50 */
	{ ns(struct netbsd32_mremap_args), 0,
	    (sy_call_t *)netbsd32_mremap },	/* 411 = netbsd32_mremap */
	{ 0, 0, 0,
	    sys_nosys },			/* 412 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 413 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 414 = unimplemented */
	{ 0, 0, 0,
	    sys_nosys },			/* 415 = unimplemented */
	{ ns(struct netbsd32___posix_fadvise50_args), 0,
	    (sy_call_t *)netbsd32___posix_fadvise50 },/* 416 = netbsd32___posix_fadvise50 */
	{ ns(struct netbsd32___select50_args), 0,
	    (sy_call_t *)netbsd32___select50 },	/* 417 = netbsd32___select50 */
	{ ns(struct netbsd32___gettimeofday50_args), 0,
	    (sy_call_t *)netbsd32___gettimeofday50 },/* 418 = netbsd32___gettimeofday50 */
	{ ns(struct netbsd32___settimeofday50_args), 0,
	    (sy_call_t *)netbsd32___settimeofday50 },/* 419 = netbsd32___settimeofday50 */
	{ ns(struct netbsd32___utimes50_args), 0,
	    (sy_call_t *)netbsd32___utimes50 },	/* 420 = netbsd32___utimes50 */
	{ ns(struct netbsd32___adjtime50_args), 0,
	    (sy_call_t *)netbsd32___adjtime50 },/* 421 = netbsd32___adjtime50 */
#if defined(LFS) || !defined(_KERNEL_OPT)
	{ ns(struct netbsd32___lfs_segwait50_args), 0,
	    (sy_call_t *)netbsd32___lfs_segwait50 },/* 422 = netbsd32___lfs_segwait50 */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 422 = excluded __lfs_segwait50 */
#endif
	{ ns(struct netbsd32___futimes50_args), 0,
	    (sy_call_t *)netbsd32___futimes50 },/* 423 = netbsd32___futimes50 */
	{ ns(struct netbsd32___lutimes50_args), 0,
	    (sy_call_t *)netbsd32___lutimes50 },/* 424 = netbsd32___lutimes50 */
	{ ns(struct netbsd32___setitimer50_args), 0,
	    (sy_call_t *)netbsd32___setitimer50 },/* 425 = netbsd32___setitimer50 */
	{ ns(struct netbsd32___getitimer50_args), 0,
	    (sy_call_t *)netbsd32___getitimer50 },/* 426 = netbsd32___getitimer50 */
	{ ns(struct netbsd32___clock_gettime50_args), 0,
	    (sy_call_t *)netbsd32___clock_gettime50 },/* 427 = netbsd32___clock_gettime50 */
	{ ns(struct netbsd32___clock_settime50_args), 0,
	    (sy_call_t *)netbsd32___clock_settime50 },/* 428 = netbsd32___clock_settime50 */
	{ ns(struct netbsd32___clock_getres50_args), 0,
	    (sy_call_t *)netbsd32___clock_getres50 },/* 429 = netbsd32___clock_getres50 */
	{ ns(struct netbsd32___nanosleep50_args), 0,
	    (sy_call_t *)netbsd32___nanosleep50 },/* 430 = netbsd32___nanosleep50 */
	{ ns(struct netbsd32_____sigtimedwait50_args), 0,
	    (sy_call_t *)netbsd32_____sigtimedwait50 },/* 431 = netbsd32_____sigtimedwait50 */
	{ 0, 0, 0,
	    sys_nosys },			/* 432 = unimplemented netbsd32___mq_timedsend50 */
	{ 0, 0, 0,
	    sys_nosys },			/* 433 = unimplemented netbsd32___mq_timedreceive50 */
	{ ns(struct netbsd32____lwp_park50_args), 0,
	    (sy_call_t *)netbsd32____lwp_park50 },/* 434 = netbsd32____lwp_park50 */
	{ ns(struct netbsd32___kevent50_args), 0,
	    (sy_call_t *)netbsd32___kevent50 },	/* 435 = netbsd32___kevent50 */
	{ ns(struct netbsd32___pselect50_args), 0,
	    (sy_call_t *)netbsd32___pselect50 },/* 436 = netbsd32___pselect50 */
	{ ns(struct netbsd32___pollts50_args), 0,
	    (sy_call_t *)netbsd32___pollts50 },	/* 437 = netbsd32___pollts50 */
	{ 0, 0, 0,
	    sys_nosys },			/* 438 = unimplemented netbsd32___aio_suspend50 */
	{ ns(struct netbsd32___stat50_args), 0,
	    (sy_call_t *)netbsd32___stat50 },	/* 439 = netbsd32___stat50 */
	{ ns(struct netbsd32___fstat50_args), 0,
	    (sy_call_t *)netbsd32___fstat50 },	/* 440 = netbsd32___fstat50 */
	{ ns(struct netbsd32___lstat50_args), 0,
	    (sy_call_t *)netbsd32___lstat50 },	/* 441 = netbsd32___lstat50 */
#if defined(SYSVSEM) || !defined(_KERNEL_OPT)
	{ ns(struct netbsd32_____semctl50_args), 0,
	    (sy_call_t *)netbsd32_____semctl50 },/* 442 = netbsd32_____semctl50 */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 442 = excluded ____semctl50 */
#endif
#if defined(SYSVSHM) || !defined(_KERNEL_OPT)
	{ ns(struct netbsd32___shmctl50_args), 0,
	    (sy_call_t *)netbsd32___shmctl50 },	/* 443 = netbsd32___shmctl50 */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 443 = excluded ____shmctl50 */
#endif
#if defined(SYSVMSG) || !defined(_KERNEL_OPT)
	{ ns(struct netbsd32___msgctl50_args), 0,
	    (sy_call_t *)netbsd32___msgctl50 },	/* 444 = netbsd32___msgctl50 */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 444 = excluded ____msgctl50 */
#endif
	{ ns(struct netbsd32___getrusage50_args), 0,
	    (sy_call_t *)netbsd32___getrusage50 },/* 445 = netbsd32___getrusage50 */
	{ ns(struct netbsd32___timer_settime50_args), 0,
	    (sy_call_t *)netbsd32___timer_settime50 },/* 446 = netbsd32___timer_settime50 */
	{ ns(struct netbsd32___timer_gettime50_args), 0,
	    (sy_call_t *)netbsd32___timer_gettime50 },/* 447 = netbsd32___timer_gettime50 */
#if defined(NTP) || !defined(_KERNEL_OPT)
	{ ns(struct netbsd32___ntp_gettime50_args), 0,
	    (sy_call_t *)netbsd32___ntp_gettime50 },/* 448 = netbsd32___ntp_gettime50 */
#else
	{ 0, 0, 0,
	    sys_nosys },			/* 448 = excluded ___ntp_gettime50 */
#endif
	{ ns(struct netbsd32___wait450_args), 0,
	    (sy_call_t *)netbsd32___wait450 },	/* 449 = netbsd32___wait450 */
	{ ns(struct netbsd32___mknod50_args), 0,
	    (sy_call_t *)netbsd32___mknod50 },	/* 450 = netbsd32___mknod50 */
	{ ns(struct netbsd32___fhstat50_args), 0,
	    (sy_call_t *)netbsd32___fhstat50 },	/* 451 = netbsd32___fhstat50 */
	{ 0, 0, 0,
	    sys_nosys },			/* 452 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 453 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 454 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 455 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 456 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 457 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 458 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 459 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 460 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 461 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 462 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 463 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 464 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 465 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 466 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 467 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 468 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 469 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 470 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 471 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 472 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 473 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 474 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 475 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 476 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 477 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 478 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 479 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 480 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 481 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 482 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 483 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 484 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 485 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 486 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 487 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 488 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 489 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 490 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 491 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 492 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 493 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 494 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 495 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 496 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 497 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 498 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 499 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 500 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 501 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 502 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 503 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 504 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 505 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 506 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 507 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 508 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 509 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 510 = filler */
	{ 0, 0, 0,
	    sys_nosys },			/* 511 = filler */
};
